// Generated by CoffeeScript 1.8.0

/*
 * Project: Lyric
 * Company: Uriel Group
 * Author: Tremayne Stewart
 */
var Lyric, Ux;

Lyric = {
  killHoldMenu: function() {
    UIActions.removeCheckHold();
    UIActions.hideHoldMenu();
    return window.clearTimeout(Lyric.State.checkoutHold_timeout);
  },
  preventIfAndroid: function(e) {
    if (Lyric.State.isAndroid) {
      return e.preventDefault();
    }
  },
  osTouchMove: function(e, touch_offset) {
    if (Lyric.State.touchAction != null) {
      if (Lyric.State.touchAction === "horiz") {
        return Lyric.preventIfAndroid(e);
      }
    } else if (Math.abs(touch_offset[0]) > Math.abs(touch_offset[1])) {
      return Lyric.State.touchAction = "horiz";
    } else {
      return Lyric.State.touchAction = "vert";
    }
  },
  defaultTouchEnd: function(e) {
    return Lyric.State.touchAction = null;
  },
  generateHash: function() {
    return Date.now();
  },
  clearCurrentProjectHash: function() {
    Lyric.State.current_project_hash = "";
    Lyric.State.current_project_index = 0;
    localStorage.removeItem("lyric_current_project_hash");
    localStorage.removeItem("lyric_current_project_index");
    localStorage.removeItem("lyric_current_project_json");
    return this.clearCurrentVerseHash();
  },
  clearCurrentVerseHash: function() {
    Lyric.State.current_verse_hash = "";
    return localStorage.removeItem("lyric_current_verse_hash");
  },
  updateCurrentProjectModified: function(project_list) {
    var move;
    if (project_list == null) {
      project_list = Data.project_list();
    }
    move = project_list.splice(Lyric.State.current_project_index, 1);
    move = move.pop();
    move[2] = Lyric.State.current_project.modified;
    project_list.unshift(move);
    Lyric.State.current_project_index = 0;
    Data.localSet("project_list", JSON.stringify(project_list));
    return project_list;
  },
  config: {
    api_url: "http://lyricapp.me/api/",
    share_url: "http://lyricapp.me/share.php?h=",
    project_settings: {
      user: {
        password: "layout_password",
        email: "layout_email"
      },
      personalize: "user_access_create_introduction_container"
    },
    lyric_settings: {
      personalize: {
        type: "layout",
        label: "Personalize",
        layout: "user_access_create_introduction_container"
      },
      nui: {
        type: "func",
        label: "Full Lyric Tour",
        func: (function() {
          return NUIActions.start();
        })
      },
      branding: {
        type: "inline",
        layout: "lyric_ugi_branding"
      },
      signout: {
        type: "action",
        label: "Sign out",
        action: {
          service: "user",
          action: "signout"
        }
      }
    },
    types: ["Music", "Poetry", "Slam", "Other"],
    colors: ["#1abc9c", "#2ecc71", "#3498db", "#3A539B", "#9b59b6", "#e74c3c", "#96281B", "#e67e22", "#f1c40f", "#F2784B", "#34495e", "#bdc3c7"],
    placeholders: {
      Music: ["Music is what feelings sound like", "Where words leave off, music begins", "Where words fail, music speaks", "Music is the strongest form of magic", "Music can change the world because it can change people", "Poetry is truth in its Sunday clothes. ~ Joseph Roux", "Poetry can be dangerous, especially beautiful poetry, because it gives the illusion of having had the experience without actually going through it. ~ Rumi", "Poetry is just the evidence of life. If your life is burning well, poetry is just the ash. ~ Leonard Cohen", "If I feel physically as if the top of my head were taken off, I know that is poetry. ~ Emily Dickinson", "Poetry is plucking at the heartstrings, and making music with them. ~ Dennis Gabor", "Poetry is the journal of a sea animal living on land, wanting to fly in the air. ~ Carl Sandburg"],
      Poetry: ["Poetry is truth in its Sunday clothes. ~ Joseph Roux", "Poetry can be dangerous, especially beautiful poetry, because it gives the illusion of having had the experience without actually going through it. ~ Rumi", "Poetry is just the evidence of life. If your life is burning well, poetry is just the ash. ~ Leonard Cohen", "If I feel physically as if the top of my head were taken off, I know that is poetry. ~ Emily Dickinson", "Poetry is plucking at the heartstrings, and making music with them. ~ Dennis Gabor", "Poetry is the journal of a sea animal living on land, wanting to fly in the air. ~ Carl Sandburg"]
    }
  },
  State: {
    History: [],
    lastPage: "",
    currentPage: "",
    getCurrentPage: function() {
      return this.currentPage;
    },
    setCurrentPage: function(add) {
      this.lastPage = this.currentPage;
      return this.currentPage = add;
    },
    current_project_hash: "",
    current_verse_hash: "",
    project_list_select_offset: 0,
    isAndroid: false,
    User: {
      stagename: "",
      background: "",
      typeIndex: 0
    }
  },
  Register: {
    Data: [],
    get: function(key) {
      return this.Data[key];
    },
    set: function(key, value) {
      var prev;
      prev = this.Data[key];
      this.Data[key] = value;
      return prev;
    },
    remove: function(key) {
      return delete this.Data[key];
    }
  },
  gotoFrom: function(from, to) {
    console.log(from, to);
    Transition[from + "__" + to]();
    return this.State.setCurrentPage(to);
  },
  goto: function(to) {
    return this.gotoFrom(this.State.getCurrentPage(), to);
  },
  gotoCommand: function(command) {
    return this.goto(command.to);
  },
  action: function(command) {
    var service;
    service = command.service.charAt(0).toUpperCase() + command.service.substring(1);
    if (command.response != null) {
      return window[service]["response"][command.action](command);
    } else if (command.error != null) {
      return window[service]["error"][command.action](command);
    } else {
      return window[service][command.action](command);
    }
  },
  ctrl: function(payload) {
    var command;
    console.log(payload);
    switch (payload.action) {
      case "signout":
        User.signout();
        break;
      case "hub":
        command = {
          service: "ux",
          action: "open_extra",
          to: "lyric_hub"
        };
        Lyric.action(command);
    }
    if (payload.alert != null) {
      return alert(payload.alert);
    }
  },
  back: function() {
    var current, to;
    current = this.State.currentPage;
    to = this.State.lastPage;
    return this.gotoFrom(current, to);
  },
  init: function() {
    React.initializeTouchEvents(true);
    document.addEventListener("touchend", Lyric.defaultTouchEnd);
    return DB.init();
  }
};

Ux = {
  selectProject: function(command) {
    var new_y;
    new_y = window["project_" + command.id].offsetTop - project_list_container.scrollTop;
    Lyric.State.project_list_select_offset = new_y;
    return Lyric.goto("editor");
  },
  project_menu_body_tab_set: function(command) {
    var btns;
    btns = [project_menu_toolbar_verses, project_menu_toolbar_settings, project_menu_toolbar_info];
    btns.forEach(function(ele) {
      return ele.classList.remove("selected");
    });
    btns[command.pos].classList.add("selected");
    return project_menu_body_container.style["-webkit-transform"] = "translateX(" + (command.pos * -100) + "%)";
  },
  open_extra: function(command) {
    ExtraPaneAction(command.to);
    return Lyric.goto("extra");
  },
  close_extra: function() {
    return Lyric.back();
  }
};

function registerAdEvents() {
    document.addEventListener('onAdFailLoad', function(data){ });
    document.addEventListener('onAdLoaded', function(data){});
    document.addEventListener('onAdPresent', function(data){});
    document.addEventListener('onAdLeaveApp', function(data){});
    document.addEventListener('onAdDismiss', function(data){});
}

// Generated by CoffeeScript 1.8.0
var HUBComponent, IntroductionActions, IntroductionController, backgrounds, headers, videos;

IntroductionActions = Reflux.createActions(["swipeLeft", "swipeRight", "skip", "beginning"]);

IntroductionController = Reflux.createStore({
  page: 0,
  listenables: IntroductionActions,
  swipeLeft: function() {
    if (this.page !== 0) {
      this.page--;
    }
    return this.trigger({
      page: this.page
    });
  },
  swipeRight: function() {
    if (this.page !== 4) {
      this.page++;
    }
    return this.trigger({
      page: this.page
    });
  },
  skip: function() {},
  beginning: function() {}
});

headers = ["Organize", "Lookup", "SafeSync", "Share", "Ready?"];

backgrounds = ["red", "blue", "green", "purple", "black"];

videos = ["0", "1", "2", "3"];

HUBComponent = React.createClass({
  mixins: [Reflux.listenTo(IntroductionController, "update")],
  getInitialState: function() {
    return {
      page: 0,
      sections: null,
      intro_vids: null
    };
  },
  componentDidMount: function() {
    var control, intro_vids, sections;
    sections = headers.map(function(section_name, i) {
      return React.DOM.h1({
        id: "header_" + i
      }, section_name);
    });
    intro_vids = videos.map(function(video_url, i) {
      return React.DOM.video({
        id: "video_" + i,
        src: video_url
      });
    });
    intro_vids.push(React.DOM.div({
      id: "video_" + videos.length
    }));
    control = headers.map(function(arg, i) {
      return React.DOM.li({
        id: "introduction_page_indicator_" + i
      });
    });
    control.push(React.DOM.div({}, "Skip?"));
    this.setState({
      sections: sections,
      intro_vids: intro_vids,
      control: control
    });
    return this.setNewPage({
      page: 0
    });
  },
  setNewPage: function(payload) {
    window["header_" + payload.page].classList.add("active");
    window["video_" + payload.page].classList.add("active");
    window["introduction_page_indicator_" + payload.page].classList.add("active");
    introduction_headers.style.background = backgrounds[payload.page];
    introduction_control.style.background = backgrounds[payload.page];
    console.log(backgrounds[payload.page]);
    return this.setState(payload);
  },
  update: function(payload) {
    var setNewPage;
    if (this.state.page === payload.page) {
      return;
    }
    window["header_" + this.state.page].classList.remove("active");
    window["video_" + this.state.page].classList.remove("active");
    window["introduction_page_indicator_" + this.state.page].classList.remove("active");
    setNewPage = this.setNewPage;
    return setTimeout((function() {
      return setNewPage(payload);
    }), 250);
  },
  onTouchStart: function() {},
  onTouchMove: function() {},
  onTouchEnd: function() {},
  render: function() {
    var page;
    page = this.state.page;
    return React.DOM.div({
      id: "introduction",
      onTouchStart: this.onTouchStart,
      onTouchMove: this.onTouchMove,
      onTouchEnd: this.onTouchEnd
    }, React.DOM.div({
      id: "introduction_videos"
    }, this.state.intro_vids), React.DOM.div({
      id: "introduction_headers"
    }, this.state.sections, React.DOM.div({
      className: "clear"
    })), React.DOM.div({
      id: "introduction_control"
    }, this.state.control));
  }
});

//React.renderComponent(new introduction({}), document.getElementById("viewport"));

// Generated by CoffeeScript 1.8.0
var UI;

UI = {
  Config: {
    textfield: {
      user_access_email: {
        placeholder: "Enter email address to begin",
        input_type: "email",
        input_class_name: "underline_textfield"
      },
      user_access_password: {
        placeholder: "Password",
        input_type: "password",
        input_class_name: "underline_textfield",
        button_id: "user_access_password_submit",
        command: "action",
        command_args: "user_access check_password"
      },
      user_access_create_password_1: {
        placeholder: "Create Password",
        input_type: "password",
        input_class_name: "underline_textfield"
      },
      user_access_create_password_2: {
        placeholder: "Repeat Password",
        input_type: "password",
        input_class_name: "underline_textfield"
      },
      user_access_create_stagename: {
        placeholder: "your name",
        input_type: "text",
        input_class_name: "underline_textfield"
      },
      editor_header_verse_title: {
        placeholder: "Verse"
      },
      project_title_input: {
        input_type: "text",
        input_class_name: "underline_textfield"
      },
      search_query: {
        placeholder: "Enter a word",
        input_type: "text",
        input_class_name: "underline_textfield",
        command: "action",
        command_args: "user_access check_password"
      },
      project_list_search: {
        placeholder: "Search for a project",
        input_class_name: "underline_textfield white"
      },
      project_list_add_title: {
        placeholder: "What are we calling it?",
        input_class_name: "underline_textfield"
      }
    },
    select: {
      user_art_type: {
        options: Lyric.config.types
      }
    },
    form: {
      user_access_email: {
        textfields_ids: ["user_access_email"],
        command: "action",
        command_args: "user_access check_email"
      },
      user_access_create_passwords: {
        textfields_ids: ["user_access_create_password_1", "user_access_create_password_2"],
        button_id: "user_access_create_password_submit",
        command: "action",
        command_args: "user_access create_password_submit"
      }
    },
    toolbar: {
      project_list_toolbar: {
        buttons: ["project_list_toolbar_show_projects", "project_list_toolbar_search"]
      },
      project_list_scroll_header_toolbar: {
        buttons: ["project_list_toolbar_show_projects", "project_list_toolbar_search"]
      },
      project_list_footer_toolbar: {
        buttons: ["project_list_footer_beta", "project_list_footer_sync", "project_list_footer_settings"]
      },
      project_menu_toolbar: {
        buttons: ["project_menu_toolbar_verses", "project_menu_toolbar_settings", "project_menu_toolbar_info"]
      },
      project_menu_music_control: {
        buttons: ["project_menu_music_rewind", "project_menu_music_play", "project_menu_music_settings"]
      },
      project_menu_footer_toolbar: {
        buttons: ["new_verse"]
      }
    }
  },
  build_solo_textfield: React.createClass({
    render: function() {
      return React.DOM.div({
        className: this.props.input_class_name
      }, React.DOM.div({}, React.DOM.input({
        type: this.props.input_type,
        id: this.props.id,
        placeholder: this.props.placeholder
      }, "")), Button.get(this.props.button_id));
    }
  }),
  build_textfield: React.createClass({
    render: function() {
      return React.DOM.input({
        type: this.props.input_type,
        id: this.props.id,
        className: this.props.input_class_name,
        placeholder: this.props.placeholder,
        value: this.props.value,
        onChange: this.props.onChange,
        defaultValue: this.props.defaultValue
      });
    }
  }),
  build_select: React.createClass({
    render: function() {
      var b;
      b = this.props.options.map(function(i, y) {
        return React.DOM.option({
          key: i,
          value: y
        }, i);
      });
      return React.DOM.select({
        id: this.props.id,
        onChange: this.props.onChange,
        defaultValue: this.props.selectedIndex
      }, b);
    }
  }),
  select: function(id, additional) {
    var config, k, _i, _len, _ref;
    config = this.Config.select[id];
    if (additional != null) {
      _ref = Object.keys(additional);
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        k = _ref[_i];
        config[k] = additional[k];
      }
    }
    config.id = id;
    return this.build_select(config);
  },
  textfield: function(id, additional) {
    var config, k, _i, _len, _ref;
    config = this.Config.textfield[id];
    if (additional != null) {
      _ref = Object.keys(additional);
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        k = _ref[_i];
        config[k] = additional[k];
      }
    }
    config.id = id;
    return this.build_textfield(config);
  },
  solo_textfield: function(id) {
    var config;
    config = this.Config.textfield[id];
    config.id = id;
    config.action = function(e) {
      e.preventDefault();
      if (config.command === "action") {
        return Lyric.action(config.command_args);
      } else {
        return Lyric.goto(config.command_args);
      }
    };
    return this.build_solo_textfield(config);
  },
  build_toolbar: React.createClass({
    render: function() {
      var btns, button_additional;
      button_additional = {
        style: this.props.button_style
      };
      btns = this.props.buttons.map(function(i) {
        return Button.get(i, button_additional);
      });
      return React.DOM.div({
        id: this.props.id,
        className: "toolbar"
      }, btns);
    }
  }),
  toolbar: function(id) {
    var config;
    config = this.Config.toolbar[id];
    config.id = id;
    if (config.buttons != null) {
      config.button_style = {
        width: 100 / config.buttons.length + "%",
        height: "100%"
      };
    }
    return this.build_toolbar(config);
  },
  list_item_hold_menu: React.createClass({
    mixins: [Reflux.listenTo(UIStore, "fromUI")],
    getInitialState: function() {
      return {
        options: [],
        delete_onclick: null
      };
    },
    fromUI: function(payload) {
      if (payload.options != null) {
        return this.setState({
          options: payload.options,
          delete_onclick: payload.delete_onclick
        });
      }
    },
    render: function() {
      var elements, option, _i, _len, _ref;
      elements = [];
      elements.push(React.DOM.div({
        className: "back"
      }, Button.get("list_hold_menu_back", {
        onclick: UIActions.hideHoldMenu
      })));
      _ref = this.state.options;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        option = _ref[_i];
        elements.push(React.DOM.div({
          className: "main_action"
        }, Button.get("list_hold_menu_main", {
          onclick: option.click,
          icon: option.icon
        })));
        elements.push(React.DOM.span({
          className: "label",
          onClick: option.click
        }, option.label));
      }
      elements.push(React.DOM.div({
        className: "remove right"
      }, Button.get("project_list_remove", {
        onclick: this.state.delete_onclick
      })));
      return React.DOM.div({
        id: "list_item_hold_menu"
      }, elements);
    }
  }),
  list_item: React.createClass({
    mixins: [Reflux.listenTo(UIStore, "fromUI")],
    getInitialState: function() {
      return {
        touch_origin: [-1, -1],
        current_touch: [-1, -1],
        trans_x: 0,
        activated: false,
        max_drag: 0,
        closed_others: false,
        sorting: false
      };
    },
    fromUI: function(payload) {
      if (payload.sorting != null) {
        return this.setState({
          sorting: payload.sorting
        });
      }
    },
    componentDidMount: function() {
      var elem;
      elem = window[this.props.id_start + "_" + this.props.hash];
      return this.setState({
        elem: elem
      });
    },
    checkingHold: false,
    checkingHold_timeout: null,
    checkHold: function() {
      if (this.checkingHold) {
        this.checkingHold = false;
        return UIActions.showHoldMenu(this.state.elem, this.props);
      }
    },
    sortTouchStart: function(e) {
      Lyric.preventIfAndroid(e);
      UIActions.startListDrag(this.state.elem);
      return this.sortTouchMove(e);
    },
    sortTouchEnd: function(e) {
      this.state.elem.style["-webkit-transform"] = "translateY(0px)";
      return UIActions.endListDrag();
    },
    sortTouchMove: function(e) {
      var posY;
      posY = e.touches[0].clientY - 31 - drag_prompt.offsetHeight + project_menu_body.scrollTop;
      this.state.elem.style["-webkit-transform"] = "translateY(" + posY + "px)";
      return UIActions.draggingListItem(e.touches[0].clientY);
    },
    onTouchStart: function(e) {
      var checkHold, touch;
      touch = e.touches[0];
      this.state.touch_origin = [e.touches[0].clientX, e.touches[0].clientY];
      this.state.handle = [e.touches[0].clientX - this.state.elem.offsetLeft, e.touches[0].clientY - this.state.elem.offsetTop];
      if (!this.state.sorting) {
        if (!this.checkingHold) {
          checkHold = this.checkHold;
          UIActions.checkHold(this.state.elem);
          this.checkoutHold_timeout = setTimeout((function() {
            return checkHold();
          }), 1000);
          Lyric.State.checkoutHold_timeout = this.checkoutHold_timeout;
          this.checkingHold = true;
        }
        return UIActions.hideHoldMenu();
      }
    },
    onTouchEnd: function(e) {
      this.touch_origin = null;
      this.checkingHold = false;
      clearTimeout(this.checkingHold_timeout);
      return UIActions.removeCheckHold();
    },
    onTouchMove: function(e) {},
    render: function() {
      var className, elem_id, elements, hash, label, onClick_command, sorting;
      elem_id = this.props.id_start + "_" + this.props.hash;
      onClick_command = this.props.click_command;
      sorting = this.state.sorting;
      hash = this.props.hash;
      elements = [];
      label = unescape(this.props.title);
      if (label.length === 0) {
        label = "Verse";
      }
      elements.push(React.DOM.div({
        className: "title",
        onClick: function(e) {
          if ((sorting != null) && !sorting) {
            return onClick_command();
          }
        }
      }, label));
      elements.push(Button.get("list_sort", {
        onTouchStart: this.sortTouchStart,
        onTouchMove: this.sortTouchMove,
        onTouchEnd: this.sortTouchEnd
      }));
      className = "";
      if (this.props.className) {
        className = this.props.className;
      }
      if (this.state.drag_over) {
        className += " sorting";
      }
      return React.DOM.li({
        id: elem_id,
        className: className,
        onTouchStart: this.onTouchStart,
        onTouchMove: this.onTouchMove,
        onTouchEnd: this.onTouchEnd
      }, elements);
    }
  })
};

// Generated by CoffeeScript 1.8.0

/*
    Tremayne Steawrt
    Config/buttons
    Button Configuration
    Lyric 3
 */
var Button;

Button = {
  template: React.createClass({
    getInitialState: function() {
      return {
        active: 0
      };
    },
    render: function() {
      var command, config;
      config = this.props;
      command = this.props.command;
      config.onClick = function() {
        if (command != null) {
          return Lyric.action(command);
        } else if (config.onclick != null) {
          return config.onclick();
        }
      };
      return React.DOM.button(config, this.props.label, React.DOM.i({
        className: 'fa ' + this.props.icon
      }, ""));
    }
  }),

  /*
      Config Sub object holds the creation configuration for buttons 
      button_id = 
          label
          icon id - font awesome code
          action type - goto, gotoFrom, action (get passed to Sys. depending on value)
          args - args for the above method call
   */
  config: {
    user_access_email_submit: {
      label: "",
      icon: "fa-angle-right",
      className: "solo_textfield_button"
    },
    user_access_password_submit: {
      label: "Login",
      className: "lead center_text white full_width"
    },
    user_access_create_password_submit: {
      label: "Let's Go ",
      icon: "fa-angle-right",
      className: "lead center_text white full_width"
    },
    user_access_create_start: {
      label: "Create Lyric Account",
      icon: "",
      className: "lead center_text white full_width"
    },
    back: {
      label: "",
      icon: "fa-angle-left",
      className: "white",
      command: {
        service: "lyric",
        action: "back"
      }
    },
    back_click: {
      label: "",
      icon: "fa-angle-left",
      className: "white"
    },
    x: {
      label: "",
      icon: "fa-times"
    },
    try_again_text: {
      label: "Try Again",
      icon: "",
      className: "red lead"
    },
    new_project: {
      label: "",
      icon: "fa-plus",
      className: "right white",
      onclick: ProjectAction.checkCreate
    },
    new_project_create: {
      label: "Create Project",
      className: "lead center_text white button"
    },
    new_project_cancel: {
      label: "Cancel ",
      className: "lead center_text white full_width",
      icon: "fa-times"
    },
    project_list_backToTop: {
      icon: "fa-chevron-up"
    },
    project_list_toolbar_show_projects: {
      label: "",
      icon: "fa-file-text-o",
      className: "white",
      key: "show_projects"
    },
    project_list_toolbar_search: {
      label: "",
      icon: "fa-search",
      className: "white",
      key: "search"
    },
    project_list_footer_settings: {
      label: "",
      icon: "fa-gear",
      key: "project_settings",
      command: {
        service: "ux",
        action: "open_extra",
        to: "settings"
      }
    },
    project_list_footer_sync: {
      label: "",
      icon: "fa-refresh",
      key: "sync_icon",
      onclick: (function() {
        return SyncAction.sync("bootcheck", "manual_sync");
      })
    },
    project_list_footer_beta: {
      label: "",
      icon: "fa-edit",
      key: "beta_icon",
      command: {
        service: "ux",
        action: "open_extra",
        to: "beta_feedback"
      }
    },
    beta_feedback_send: {
      label: "Send!",
      className: "button"
    },
    project_list_remove: {
      icon: "fa-times"
    },
    list_hold_menu_back: {
      icon: "fa-reply"
    },
    list_hold_menu_main: {
      icon: ""
    },
    project_list_view: {
      icon: "fa-eye",
      onclick: ProjectAction.transcript
    },
    sync_now: {
      label: "Sync Now",
      onclick: SyncAction.manual
    },
    done_sorting: {
      label: "Done",
      onclick: UIActions.doneSorting
    },
    list_sort: {
      label: "",
      icon: "fa-sort",
      className: "list_sort_button"
    },
    back_to_project_list: {
      icon: "fa-angle-left",
      className: "white",
      onclick: ProjectAction.backToProjectList
    },
    back_from_extra: {
      icon: "fa-angle-left",
      className: "white left",
      onclick: function() {
        return Lyric.back();
      }
    },
    close_beta: {
      icon: "fa-times",
      className: "white right",
      onclick: function() {
        return Lyric.back();
      }
    },
    do_search: {
      icon: "fa-search",
      className: "white"
    },
    search_scroll_to_top: {
      icon: "fa-chevron-up",
      color: "white"
    },
    new_verse: {
      icon: "fa-plus",
      onclick: VerseStore.add
    },
    view_project: {
      icon: "fa-eye"
    },
    generate_share_hash: {
      icon: " fa-external-link",
      label: " Generate New Share Link"
    },
    generate_share_hash_undo: {
      icon: " fa-undo",
      label: "Unshare Project"
    },
    project_menu_toolbar_verses: {
      icon: "fa-file-text",
      className: "selected",
      command: {
        service: "ux",
        action: "project_menu_body_tab_set",
        pos: 0
      }
    },
    project_menu_toolbar_settings: {
      icon: "fa-gear",
      command: {
        service: "ux",
        action: "project_menu_body_tab_set",
        pos: 1
      }
    },
    project_menu_toolbar_info: {
      icon: "fa-share-alt",
      command: {
        service: "ux",
        action: "project_menu_body_tab_set",
        pos: 2
      }
    },
    project_menu_music_rewind: {
      icon: "fa-backward"
    },
    project_menu_music_play: {
      icon: "fa-play-circle"
    },
    project_menu_music_settings: {
      icon: "fa-music"
    },
    editor_header_menu: {
      icon: "fa-bars",
      command: {
        service: 'lyric',
        action: "gotoCommand",
        to: "project_menu"
      }
    },
    editor_header_search: {
      icon: "fa-search",
      command: {
        service: 'lyric',
        action: "gotoCommand",
        to: "search"
      }
    }
  },
  create: function(id, additional) {
    var config, k, _i, _len, _ref;
    config = this.config[id];
    if (additional != null) {
      _ref = Object.keys(additional);
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        k = _ref[_i];
        config[k] = additional[k];
      }
    }
    config.id = id;
    return new this.template(config);
  },

  /*
      Returns the react element for the button requested by @id. If the button has not been initialized 
      into a rect element from the config then it is initialized, saved to it's respective variable, and returned
      @param   id - the identifier for the requested button
      @return  A React element represenation of button
   */
  get: function(id, additional) {
    var button;
    button = this[id];
    button = this.create(id, additional);
    this[id] = button;
    return button;
  }
};

// Generated by CoffeeScript 1.8.0


// Generated by CoffeeScript 1.8.0
var Transition;

Transition = {
  fadeOutSlideLeft: function(args) {
    return Velocity(args.element, {
      opacity: [0, 1],
      translateX: ["-20px", 0]
    }, {
      duration: 300,
      complete: args.complete
    });
  },
  fadeOutSlideRight: function(args) {
    return Velocity(args.element, {
      opacity: 0,
      translateX: ["20px", 0]
    }, {
      duration: 300,
      easing: "easeInQuart",
      complete: args.complete
    });
  },
  fadeIn: function(args) {
    return Velocity(args.element, {
      opacity: [1, 0]
    }, {
      duration: 300,
      complete: args.complete
    });
  },
  fadeOut: function(args) {
    args.element.style.opacity = 0;
    return Velocity(args.element, {
      opacity: [0, 1]
    }, {
      duration: 300,
      complete: args.complete
    });
  },
  fadeInSlideRight: function(args) {
    args.element.style.opacity = 0;
    return Velocity(args.element, {
      opacity: 1,
      translateX: ["0px", "20px"]
    }, {
      duration: 300,
      easing: args.easing ? args.easing : "easeOutQuart",
      complete: args.complete
    });
  },

  /*
      User access email and user access password
   */
  user_access_email__user_access_password: function() {
    user_access_password_container.classList.remove("invisible");
    this.fadeOutSlideLeft({
      element: user_access_email_container
    });
    return this.fadeIn({
      element: user_access_password_container,
      complete: (function() {
        return user_access_password.focus();
      })
    });
  },
  user_access_password__user_access_email: function() {
    user_access_email_container.classList.remove("invisible");
    Velocity(user_access_password_container, "reverse");
    Velocity(user_access_email_container, "reverse", {
      complete: function() {
        return user_access_password_container.classList.add("invisible");
      }
    });
  },
  user_access_email__user_access_create_password: function() {
    user_access_create_passwords_container.classList.remove("invisible");
    this.fadeOutSlideLeft({
      element: user_access_email_container,
      complete: function() {
        return user_access_email_container.classList.add("invsible");
      }
    });
    return this.fadeIn({
      element: user_access_create_passwords_container
    });
  },
  user_access_create_password__user_access_email: function() {
    user_access_email_container.classList.remove("invisible");
    Velocity(user_access_create_passwords_container, "reverse");
    Velocity(user_access_email_container, "reverse", {
      complete: function() {
        return user_access_create_passwords_container.classList.add("invisible");
      }
    });
  },
  user_access_create_password__user_access_create_introduction: function() {
    user_access_create_introduction_container.classList.remove("invisible");
    this.fadeOutSlideLeft({
      element: user_access_create_passwords_container,
      complete: (function() {
        return user_access_create_passwords_container.classList.add("invsible");
      })
    });
    return this.fadeIn({
      element: user_access_create_introduction_container,
      complete: (function() {
        return user_access_create_stagename.focus();
      })
    });
  },
  user_access_create_introduction__user_access_create_password: function() {
    user_access_create_passwords_container.classList.remove("invisible");
    Velocity(user_access_create_passwords_container, "reverse");
    return Velocity(user_access_create_introduction_container, "reverse", {
      complete: function() {
        return user_access_create_introduction_container.classList.add("invisible");
      }
    });
  },

  /*
      Project List
   */
  project_list__project_add: function() {
    project_list_overlay.style["display"] = "block";
    this.fadeIn({
      element: project_list_overlay
    });
    return Velocity(project_list_add_container, {
      translateY: [135, 0]
    }, {
      duration: 300,
      complete: function() {
        return project_list_add_title.focus();
      }
    });
  },
  project_add__project_list: function() {
    this.fadeOut({
      element: project_list_overlay,
      complete: function() {
        return project_list_overlay.style["display"] = "none";
      }
    });
    return Velocity(project_list_add_container, {
      translateY: [0, 135]
    }, {
      duration: 300,
      complete: function() {}
    });
  },
  project_list__editor: function() {
    lyric_workspace.style["display"] = "block";
    project_menu_footer_toolbar.style["display"] = "none";
    return Velocity(lyric_workspace, {
      translateY: [0, Lyric.State.project_list_select_offset],
      translateX: [0, 0]
    }, {
      duration: 300,
      easing: "easeInQuad",
      complete: function() {
        editor_activator.classList.add("invisible");
        return project_menu_footer_toolbar.style["display"] = "block";
      }
    });

    /*Animate individual list items
    for element,index in Lyric.State.current_project.verses_index
        console.log element
        if window["verse_"+element]?
            window["verse_"+element].style.transform="translateY(100px)"
        delay = Lyric.State.current_project.verses_index-index
        Velocity(window["verse_"+element],
            {
                translateY:[0,100]
                opacity:[1,0]
            },
            {
                duration: 200
                delay:((2+index)*50)
            }
        )
     */
  },

  /*
      Project Menu
   */
  project_menu__editor: function() {
    return Velocity(lyric_workspace_container, {
      translateX: "-93%"
    }, {
      duration: 300,
      easing: "easeIn",
      complete: function() {
        var ux;
        editor_activator.classList.add("invisible");
        ux = {
          service: "ux",
          action: "project_menu_body_tab_set",
          pos: 0
        };
        return Lyric.action(ux);
      }
    });
  },

  /*
      Editor
   */
  editor__project_menu: function() {
    Velocity(lyric_workspace_container, {
      translateX: ["0", "-93%"]
    }, {
      duration: 300,
      easing: "easeOutQuad",
      complete: function() {
        editor_activator.classList.remove("invisible");
        return Lyric.clearCurrentVerseHash();
      }
    });
    return VerseAction.toProjectMenu();
  },
  editor__search: function() {
    search.classList.remove("invisible");
    return this.fadeInSlideRight({
      element: search
    });
  },
  search__editor: function() {
    return this.fadeOutSlideRight({
      element: search,
      complete: function() {
        return search.classList.add("invisible");
      }
    });
  },
  project_menu__project_list: function() {
    return this.fadeOutSlideRight({
      element: lyric_workspace,
      complete: function() {
        lyric_workspace.style.removeProperty('-webkit-transform');
        lyric_workspace_container.style.removeProperty("-webkit-transform");
        lyric_workspace_container.style.removeProperty("transform");
        lyric_workspace.style["opacity"] = "1";
        lyric_workspace.style["display"] = "none";
        return Lyric.clearCurrentProjectHash();
      }
    });
  },
  project_list__extra: function() {
    return Velocity(app, {
      translateX: "100%"
    }, {
      duration: 300
    });
  },
  extra__project_list: function() {
    return Velocity(app, {
      translateX: "0%"
    }, {
      duration: 300
    });
  },
  project_menu__extra: function() {
    return this.project_list__extra();
  },
  extra__project_menu: function() {
    return this.extra__project_list();
  },
  editor__extra: function() {
    return this.project_list__extra();
  },
  extra__editor: function() {
    return this.extra__project_list();
  }
};

// Generated by CoffeeScript 1.8.0
var Data, NUIActions, NUIStore, Project, ProjectAction, ProjectStore, Reference, ReferenceAction, ReferenceStore, UIActions, UIStore, User, UserAction, UserStore, VerseAction, VerseStore;

Lyric.State.nui = true;

NUIActions = Reflux.createActions(["next", "actionNext", "skip", "start", "finish"]);

NUIStore = Reflux.createStore({
  pages: [
    ["Welcome to Lyric", "Let me show you around", ["h", "w-66", "40", "50"], true, null, 120], [
      "Okay, let's create a new project", "Touch the + icon above", ["0", "w-66", "40", "50"], false, (function() {
        return ProjectAction.checkCreate();
      }), 150
    ], ["Name it!", "And touch Create Project", ["1", "1", "132", "w"], false, null, 150, true], ["What's in a name?", "Add meaning to verses by giving them names.  Go ahead and name this verse 'intro' then touch Next", ["1", "50", "50", "w-100"], true, null, 50, true], ["Distraction Free writing", "And inspiring quotes so you can stay inspired and focused", ["1", "1", "h", "w"], true, null, 150], ["Need to Lookup a word?", "With definitions, synonyms, and a rhyming dictionary the perfect word is always at your fingertips", ["1", "w-50", "46", "50"], true, null, 60], [
      "Let's go to the Project Menu", "Touch the bars above", ["1", "1", "46", "47"], false, (function() {
        var command;
        command = {
          service: 'lyric',
          action: "gotoCommand",
          to: "project_menu"
        };
        return Lyric.action(command);
      }), 65, false
    ], ["Add Verses", "To grow your project", ["h-50", "1", "50", "w-22"], true, null, 320, false], ["Rearrange", "Touch and hold to sort your verses", ["80", "1", "50", "w-22"], true, null, 150, false], ["Ready to Share?", "Generate a link and let the world have it", ["40", "w-w/3", "38", "w/3-30"], true, null, 100, false], [
      "Let's go back to the Project List", "Touch the < above", ["1", "1", "50", "50"], false, (function() {
        var command;
        command = {
          service: 'lyric',
          action: "gotoCommand",
          to: "project_list"
        };
        return Lyric.action(command);
      }), 65, false
    ], ["Ready to Perform", "Touch and hold to view the full project", ["190", "1", "50", "w"], true, null, 250, false], ["Search!", "And easily find projects", ["140", "1", "50", "w"], true, null, 200, false], ["Check on Syncing", "Or manually sync, just to make sure!", ["h-40", "w/3", "40", "w/3"], true, null, 300, false], ["Settings", "Personalization and other options", ["h-40", "w/3*2", "40", "w/3"], true, null, 290, false], ["Lyric HUB", "Stay in-the-know with things we're doing!", ["1", "1", "50", "90"], true, null, 60, false], ["Let us Know!", "Have ideas? issues? or just want to say hi", ["h-40", "1", "40", "(w/3)"], true, null, 300, false], ["I think you're ready!", "", ["h", "1", "40", "(w/3)"], false, null, 100, false, true]
  ],
  pageIndex: -1,
  listenables: NUIActions,
  finish: function() {
    return this.trigger({
      visible: false
    });
  },
  start: function() {
    var command;
    command = {
      service: 'lyric',
      action: "gotoCommand",
      to: "project_list"
    };
    if (Lyric.State.getCurrentPage() !== "project_list") {
      Lyric.action(command);
    }
    this.pageIndex = -1;
    this.trigger({
      visible: true
    });
    this.next();
    return UserAction.setBackground();
  },
  actionNext: function() {
    if (this.pages[this.pageIndex][4] != null) {
      this.pages[this.pageIndex][4]();
    }
    return this.next();
  },
  next: function() {
    var focus, full, i, overlays, payload, px, zero, _i;
    ++this.pageIndex;
    overlays = [[], [], [], []];
    focus = this.pages[this.pageIndex][2].map(function(prop) {
      return eval(prop.replace(/w/g, app.offsetWidth).replace(/h/g, app.offsetHeight));
    });
    zero = "0px";
    full = "100%";
    px = "px";
    for (i = _i = 0; _i <= 3; i = ++_i) {
      overlays[i][0] = zero;
      overlays[i][1] = zero;
      overlays[i][2] = zero;
      overlays[i][3] = zero;
    }
    overlays[0][3] = full;
    overlays[0][2] = focus[0] + px;
    overlays[1][0] = focus[0] + focus[2] + px;
    overlays[1][2] = full;
    overlays[1][3] = full;
    overlays[2][0] = focus[0] + px;
    overlays[2][2] = focus[2] + px;
    overlays[2][3] = focus[1] + px;
    overlays[3][0] = focus[0] + px;
    overlays[3][1] = focus[1] + focus[3] + px;
    overlays[3][2] = focus[2] + px;
    overlays[3][3] = full;
    payload = {
      heading: this.pages[this.pageIndex][0],
      sub_text: this.pages[this.pageIndex][1],
      overlay_config: overlays,
      show_next: this.pages[this.pageIndex][3],
      passthrough: this.pages[this.pageIndex][4] == null,
      focus: focus,
      blurbY: this.pages[this.pageIndex][5],
      allow_full_passthrough: this.pages[this.pageIndex][6],
      done: this.pages[this.pageIndex][7],
      page: this.pageIndex
    };
    return this.trigger(payload);
  },
  skip: function() {
    return this.trigger();
  }
});

UIActions = Reflux.createActions(["startSorting", "startListDrag", "draggingListItem", "endListDrag", "doneSorting", "checkHold", "removeCheckHold", "showHoldMenu", "hideHoldMenu"]);

UIStore = Reflux.createStore({
  listenables: UIActions,
  holding: false,
  holding_timeout: null,
  checkHold: function(elem) {
    elem.appendChild(list_item_hold_indicator);
    list_item_hold_indicator.style.display = "block";
    if (!this.holding) {
      this.holding_timeout = setTimeout((function() {
        return list_item_hold_indicator.classList.add("grow");
      }), 50);
      return this.holding = true;
    }
  },
  removeCheckHold: function() {
    this.holding = false;
    clearTimeout(this.holding_timeout);
    app.appendChild(list_item_hold_indicator);
    list_item_hold_indicator.style.display = "none";
    return list_item_hold_indicator.classList.remove("grow");
  },
  showHoldMenu: function(elem, config) {
    this.removeCheckHold();
    list_item_hold_indicator.classList.remove("grow");
    list_item_hold_menu.style.display = "block";
    elem.appendChild(list_item_hold_menu);
    return this.trigger({
      options: config.options,
      delete_onclick: config.delete_onclick
    });
  },
  hideHoldMenu: function() {
    app.appendChild(list_item_hold_menu);
    return list_item_hold_menu.style.display = "none";
  },
  drag_total_elements: 0,
  drag_element: null,
  drag_element_index: null,
  drag_element_new_index: null,
  drag_element_prefix: null,
  drag_element_container: null,
  drag_element_scrollActiviate: 25,
  drag_element_placeholder_index: null,
  sT: 0,
  doneSorting: function() {
    var payload;
    payload = {
      sorting: false
    };
    this.trigger(payload);
    project_menu_body.classList.remove("sorting", "user_background");
    project_menu_body.style.background = "";
    this.drag_total_elements = null;
    this.drag_element_prefix = null;
    this.drag_element_container = null;
    ProjectAction.modifiedCurrentProject();
    return project_menu_body_verses.style.top = "";
  },
  startSorting: function(elem) {
    var payload;
    this.hideHoldMenu();
    payload = {
      sorting: true
    };
    this.trigger(payload);
    project_menu_body.classList.add("sorting", "user_background");
    UserAction.setBackground();
    this.drag_element_prefix = elem.id.substr(0, elem.id.indexOf("_"));
    this.drag_total_elements = elem.parentElement.childNodes;
    this.drag_total_ids = Lyric.State.current_project.verses_index;
    this.drag_element_container = elem.parentElement.parentElement;
    return project_menu_body_verses.style.top = drag_prompt.offsetHeight + "px";
  },
  startListDrag: function(elem) {
    project_menu_body_verses.style.overflowY = "visible";
    this.drag_element = elem;
    this.sT = project_menu_body.scrollTop;
    elem.classList.add("dragging");
    list_placeholder.style.display = "block";
    return project_menu_body.style.overflow = "hidden";
  },
  draggingListItem: function(touchY) {
    var actionY, activeIndex, id_over, placeholder_location, scrollTouchY;
    scrollTouchY = touchY - drag_prompt.offsetHeight;
    actionY = scrollTouchY + project_menu_body.scrollTop;
    placeholder_location = "beforeBegin";
    activeIndex = Math.floor(actionY / 62);
    if (activeIndex < 0) {
      activeIndex = 0;
    }
    if (this.drag_element_index == null) {
      this.drag_element_index = activeIndex;
    }
    if (activeIndex === 0) {
      if (this.drag_element_index === 0) {
        this.drag_element_placeholder_index = 1;
      } else {
        this.drag_element_placeholder_index = 0;
      }
    } else if (this.drag_element_index === this.drag_total_ids.length - 1) {
      this.drag_element_placeholder_index = this.drag_element_index - 1;
      if (this.drag_element_index <= activeIndex) {
        placeholder_location = "afterEnd";
      } else {
        this.drag_element_placeholder_index = activeIndex;
      }
    } else {
      if (activeIndex < this.drag_total_ids.length - 1) {
        if (activeIndex === this.drag_element_index - 1) {
          this.drag_element_placeholder_index = this.drag_element_index - 2;
          placeholder_location = "afterEnd";
        } else if (activeIndex === this.drag_element_index - 2) {
          this.drag_element_placeholder_index = activeIndex;
        } else {
          this.drag_element_placeholder_index = activeIndex + 1;
        }
      } else {
        this.drag_element_placeholder_index = this.drag_total_ids.length - 1;
        placeholder_location = "afterEnd";
      }
    }
    id_over = this.drag_element_prefix + "_" + this.drag_total_ids[this.drag_element_placeholder_index];
    window[id_over].insertAdjacentElement(placeholder_location, list_placeholder);
    this.drag_element_new_index = activeIndex;
    if (project_menu_body.scrollTop > 0) {
      if (scrollTouchY < this.drag_element_scrollActiviate) {
        project_menu_body.scrollTop -= 10;
        this.sT = project_menu_body.scrollTop;
      }
    }
    if (project_menu_body.scrollTop < this.drag_element.parentElement.offsetHeight - project_menu_body.offsetHeight + 100) {
      if (scrollTouchY > this.drag_element_container.offsetHeight - this.drag_element_scrollActiviate) {
        project_menu_body.scrollTop += 10;
        return this.sT = project_menu_body.scrollTop;
      }
    }
  },
  endListDrag: function() {
    var i, p, verses_index;
    project_menu_body_verses.style.overflowY = "scroll";
    list_placeholder.style.display = "none";
    project_menu_body.style.overflow = "";
    app.appendChild(list_placeholder);
    if (this.drag_element_index !== this.drag_element_new_index) {
      verses_index = Lyric.State.current_project.verses_index;
      i = verses_index.splice(this.drag_element_index, 1);
      i = i[0];
      verses_index.splice(this.drag_element_new_index, 0, i);
      this.trigger({
        verses_index: verses_index
      });
      p = JSON.parse(JSON.stringify(Lyric.State.current_project));
      DB.updateProject(p);
    }
    this.drag_element.classList.remove("dragging");
    project_menu_body.scrollTop = this.sT;
    this.drag_element = null;
    this.drag_element_index = null;
    return this.drag_element_new_index = null;
  }
});

UserAction = Reflux.createActions(["updateStagename", "setBackground", "updateBackground", "updateType", "checkEmail", "checkCreatePassword", "createUser", "login"]);

UserStore = Reflux.createStore({
  listenables: UserAction,
  init: function() {},
  checkEmail: function() {
    var req;
    check_email_button.classList.add("loading");
    check_email_button.innerHTML = "<i class='fa fa-spinner fa-spin'></i>";
    check_email_button.disabled = true;
    req = {
      service: "user",
      action: "check_email",
      email: user_access_email.value
    };
    return Sync.request(req);
  },
  checkCreatePassword: function(p1, p2) {
    if (p1.length < 8) {
      alert("Your password needs to be at least 8 characters long");
      return;
    }
    if (p1 === p2 && p1.length > 0) {
      return Lyric.goto("user_access_create_introduction");
    } else {
      alert("Your passwords needs to match !");
    }
  },
  login: function() {
    var req;
    user_access_password_submit.innerHTML = "<i class='fa fa-spinner fa-spin'></i>";
    user_access_password_submit.disabled = true;
    req = {
      service: "user",
      action: "login",
      email: user_access_email.value,
      pwd: user_access_password.value,
      type: "app"
    };
    return Sync.request(req);
  },
  createUser: function() {
    var req, response;
    response = "";
    if (user_access_create_stagename.value.length === 0) {
      response += "\tSet your stage name ";
    }
    if (Lyric.State.User.background.length === 0) {
      response += "\n\n\tPick a color!";
    }
    if (response.length !== 0) {
      alert("Hey, \n You forgot to\n" + response);
      return;
    }
    user_access_create_start.innerHTML = "<i class='fa fa-spinner fa-spin'></i>";
    user_access_create_start.disabled = true;
    req = {
      service: "user",
      action: "create",
      email: user_access_email.value,
      pass1: user_access_create_password_1.value,
      pass2: user_access_create_password_2.value,
      art_type: user_art_type.value,
      color: Lyric.State.User.background,
      stagename: user_access_create_stagename.value
    };
    return Sync.request(req);
  },
  updateBackground: function(color, custom) {
    if (custom == null) {
      custom = false;
    }
    if (custom) {
      color = "#" + prompt("Enter HEX value of the color. Don't include the #");
    }
    Lyric.State.User.background = color;
    Data.localSet("user_background", color);
    return this.setBackground();
  },
  setBackground: function() {
    var elem, _i, _len, _ref, _results;
    _ref = document.getElementsByClassName("user_background");
    _results = [];
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      elem = _ref[_i];
      _results.push(elem.style.background = Lyric.State.User.background);
    }
    return _results;
  },
  updateStagename: function(name) {
    var payload, sHidden, size;
    Lyric.State.User.stagename = name;
    Data.localSet("user_stagename", name);
    sHidden = stagename_scale;
    sHidden.innerHTML = name;
    sHidden.style["font-size"] = "45px";
    size = 45;
    while (sHidden.offsetWidth > 150) {
      size = size - 1;
      sHidden.style["font-size"] = size + "px";
    }
    size -= 1;
    greeting_stagename.style["font-size"] = size + "px";
    greeting_stagename.style["padding-top"] = (45 - size) + "px";
    payload = {
      label: "stagename",
      name: name
    };
    return this.trigger(payload);
  },
  updateType: function(typeIndex) {
    var payload, type;
    Lyric.State.User.typeIndex = typeIndex;
    type = Lyric.config.types[typeIndex];
    if (typeIndex === Lyric.config.types.length - 1) {
      type = "thing";
    }
    Data.localSet("user_type", typeIndex);
    payload = {
      label: "type",
      type: type
    };
    return this.trigger(payload);
  },
  updateTypeText: function(type) {},
  addBetaNote: function() {
    var beta_note_list, note;
    note = beta_textarea.value;
    return beta_note_list = Data.localGet("beta_notes");
  }
});

User = {

  /*
      checkes email against server results
          0 - cannot reach server
          1 - email can login
          2 - no account / create
   */
  check_password: function(command) {},

  /*
      make sure paswwords match and shit
   */
  check_created_passwords: function(command) {},
  select_color: function(command) {
    personal_background_color.style.background = command.color;
    return this.info.color = command.color;
  },
  signout: function() {
    var i, toDelete, _i, _len;
    toDelete = ["beta_notes", "delete_log", "project_list", "user_account", "user_background", "user_hash", "user_stagename", "user_type", "last_synced"];
    for (_i = 0, _len = toDelete.length; _i < _len; _i++) {
      i = toDelete[_i];
      localStorage.removeItem("lyric_" + i);
    }
    Lyric.State.setCurrentPage("user_access_email");
    ExtraPaneAction("user_access");
    app.style["-webkit-transform"] = "translateX(100%)";
    return DB.deleteDB();
  },
  error: {
    check_email: function(payload) {
      alert("Please connect to the internet");
      check_email_button.classList.remove("loading");
      check_email_button.innerHTML = "Continue";
      return check_email_button.disabled = false;
    },
    login: function(payload) {
      alert("Please connect to the internet");
      user_access_password_submit.innerHTML = "Login";
      return user_access_password_submit.disabled = false;
    },
    create: function() {
      alert("Please connect to the internet");
      user_access_create_start.innerHTML = "Create Lyric Account";
      return user_access_create_start.disabled = false;
    }
  },
  response: {
    check_email: function(payload) {
      check_email_button.classList.remove("loading");
      check_email_button.innerHTML = "Continue";
      check_email_button.disabled = false;
      if (payload.exists) {
        return Lyric.goto("user_access_password");
      } else if (!payload.er) {
        return Lyric.goto("user_access_create_password");
      }
    },
    login: function(payload) {
      var user;
      user_access_password_submit.innerHTML = "Continue";
      user_access_password_submit.disabled = false;
      if (payload.error != null) {
        return alert(payload.error);
      } else {
        user = payload.userinfo;
        UserAction.updateType(user.art_type);
        UserAction.updateStagename(user.stagename);
        UserAction.updateBackground(user.color);
        Lyric.State.User.hash = user.hash;
        Data.localSet("user_hash", user.hash);
        Lyric.State.Account = user.account;
        Data.localSet("user_account", JSON.stringify(user.account));
        Lyric.State.setCurrentPage("extra");
        Lyric.State.lastPage = "project_list";
        Lyric.back();
        return SyncAction.sync("bootcheck", "login");
      }
    },
    create: function(payload) {
      var user;
      if (payload.error != null) {
        return alert(payload.error);
      } else {
        user = payload.userinfo;
        Lyric.State.User.hash = user.hash;
        Data.localSet("user_hash", user.hash);
        Lyric.State.Account = user.account;
        Data.localSet("user_account", JSON.stringify(user.account));
        Lyric.State.setCurrentPage("extra");
        Lyric.State.lastPage = "project_list";
        return Lyric.back();
      }
    }
  }
};

ProjectAction = Reflux.createActions(["select", "create", "retrieved_project", "transcript", "transcript_view", "remove", "checkCreate", "updateTitle", "saveUpdatedTitle", "createShareHash", "updateShareHash", "modifiedCurrentProject", "backToProjectList"]);

ProjectStore = Reflux.createStore({
  listenables: ProjectAction,
  init: function() {},
  backToProjectList: function() {
    var command, payload;
    command = {
      service: 'lyric',
      action: "gotoCommand",
      to: "project_list"
    };
    Lyric.action(command);
    payload = {
      label: "project",
      project: Data.factory.project("empty")
    };
    return this.trigger(payload);
  },
  unShareHash: function() {
    var payload;
    payload = {
      service: "project",
      action: "un_share",
      hash: Lyric.State.User.hash,
      project_hash: Lyric.State.current_project.hash
    };
    return Sync.request(payload);
  },
  createShareHash: function() {
    var ans, payload;
    if (Lyric.State.current_project.share != null) {
      ans = confirm("Generating a new share link will make the previous link no longer work.\n\nContinue?");
      if (!ans) {
        return;
      }
    }
    SyncAction.sync("bootcheck", "manual_sync");
    payload = {
      service: "project",
      action: "get_share",
      hash: Lyric.State.User.hash,
      project_hash: Lyric.State.current_project.hash
    };
    return Sync.request(payload);
  },
  updateShareHash: function(share) {
    var p, payload;
    Lyric.State.current_project.share = share;
    p = JSON.parse(JSON.stringify(Lyric.State.current_project));
    DB.updateProject(p);
    payload = {
      label: "project",
      project: p
    };
    return this.trigger(payload);
  },
  transcript: function(hash) {
    var project;
    hash = parseInt(hash);
    return project = DB.getProject(hash, ProjectAction.transcript_view);
  },
  transcript_view: function(project) {
    var command, payload;
    Lyric.State.current_project = project;
    payload = {
      label: "transcript",
      project: project
    };
    this.trigger(payload);
    command = {
      service: "ux",
      action: "open_extra",
      to: "transcript"
    };
    return Lyric.action(command);
  },
  updateTitle: function(title) {
    var payload;
    payload = {
      updated_title: title
    };
    this.saveUpdatedTitle(title);
    return this.trigger(payload);
  },
  modifiedCurrentProject: function(payload) {
    var entry, index, project_list;
    project_list = Data.project_list();
    index = Lyric.State.current_project_index;
    entry = project_list.splice(index, 1);
    entry = entry.pop();
    if ((payload != null) && (payload.title != null)) {
      entry[1] = payload.title;
    }
    Lyric.State.current_project.modified = Date.now();
    entry[2] = Lyric.State.current_project.modified;
    project_list.unshift(entry);
    Data.localSet("project_list", JSON.stringify(project_list));
    Lyric.State.current_project_index = 0;
    payload = {
      label: "project_list",
      data: project_list
    };
    this.trigger(payload);
    return SyncAction.syncCheck();
  },
  saveUpdatedTitle: function(title) {
    var p, project_list;
    this.modifiedCurrentProject({
      title: title
    });
    project_list = Data.project_list();
    Lyric.State.current_project.title = title;
    p = JSON.parse(JSON.stringify(Lyric.State.current_project));
    return DB.updateProject(p);
  },
  select: function(hash, index) {
    var project;
    hash = parseInt(hash);
    Lyric.State.current_project_hash = hash;
    Data.localSet("current_project_hash", hash);
    Data.localSet("current_project_index", index);
    Lyric.State.current_project_index = index;
    return project = DB.getProject(hash, ProjectAction.retrieved_project);
  },
  retrieved_project: function(project) {
    var payload, startup_with_project, startup_with_verse, ux, verseHash;
    Lyric.State.current_project = project;
    startup_with_project = Lyric.Register.get("startup_with_project");
    if (startup_with_project == null) {
      startup_with_project = false;
    }
    Lyric.Register.remove("startup_with_project");
    startup_with_verse = Lyric.Register.get("startup_with_verse");
    if (startup_with_verse == null) {
      startup_with_verse = false;
    }
    Lyric.Register.remove("startup_with_verse");
    if (startup_with_verse) {
      verseHash = Lyric.State.current_verse_hash;
    } else {
      verseHash = project.verses_index[0];
    }
    Velocity.mock = false;
    payload = {
      label: "project",
      project: project
    };
    this.trigger(payload);
    project_title_input.value = project.title;
    VerseAction.select(verseHash, !startup_with_verse);
    ux = {
      service: "ux",
      action: "project_menu_body_tab_set",
      pos: 0
    };
    Lyric.action(ux);
    ux = {
      service: "ux",
      action: "selectProject",
      id: project.hash
    };
    return Lyric.action(ux);
  },
  checkCreate: function() {
    var command;
    command = {
      service: "lyric",
      action: "gotoCommand",
      to: "project_add"
    };
    if (parseInt(Lyric.State.Account.project_limit) !== 0 && Lyric.State.Account.project_limit <= Data.project_list().length) {
      command = {
        service: "ux",
        action: "open_extra",
        to: "notice_project_limit"
      };
    }
    return Lyric.action(command);
  },
  create: function(title) {
    var command, payload, project, project_list;
    project = Data.factory.project();
    project.title = title;
    project.hash = Lyric.generateHash();
    DB.addProject(project);
    project_list = Data.project_list();
    project_list.unshift([project.hash, project.title, project.modified]);
    Data.localSet("project_list", JSON.stringify(project_list));
    payload = {
      label: "project_list",
      data: project_list
    };
    this.trigger(payload);
    command = {
      service: "lyric",
      action: "gotoCommand",
      to: "project_list"
    };
    Lyric.action(command);
    ProjectAction.select(project.hash);
    if (Lyric.State.nui) {
      return NUIActions.next();
    }
  },
  remove: function(hash) {
    var delete_log, e, i, payload, project_list, remove, _i, _len, _results;
    app.appendChild(list_item_hold_menu);
    list_item_hold_menu.style.display = "none";
    remove = confirm("Are you sure you want to delete this project? (this cannot be undone)");
    if (remove) {
      if (Data.localGet("delete_log") != null) {
        delete_log = JSON.parse(Data.localGet("delete_log"), []);
      } else {
        delete_log = [];
      }
      delete_log.push(hash);
      Data.localSet("delete_log", JSON.stringify(delete_log));
      DB.deleteProject(hash);
      project_list = Data.project_list();
      _results = [];
      for (i = _i = 0, _len = project_list.length; _i < _len; i = ++_i) {
        e = project_list[i];
        if ((e != null) && e[0] === hash) {
          project_list.splice(i, 1);
          Data.localSet("project_list", JSON.stringify(project_list));
          payload = {
            label: "project_list",
            data: project_list
          };
          this.trigger(payload);
          break;
        } else {
          _results.push(void 0);
        }
      }
      return _results;
    }
  }
});

Project = {
  selectProject: function(command) {
    var ux;
    Lyric.State.current_project_hash = command.hash;
    ux = {
      service: "ux",
      action: "selectProject",
      id: command.hash
    };
    return Lyric.action(ux);
  },
  response: {
    get_share: function(data) {
      return ProjectAction.updateShareHash(data.share);
    },
    un_share: function(data) {
      return ProjectAction.updateShareHash("");
    }
  }
};

VerseAction = Reflux.createActions(["select", "add", "update", "updateTitle", "remove", "toProjectMenu"]);

VerseStore = Reflux.createStore({
  listenables: VerseAction,
  init: function() {},
  select: function(hash, set) {
    var payload, placeholder_text, placeholders, typeIndex, verse;
    if (set == null) {
      set = false;
    }
    Lyric.State.current_verse_hash = hash;
    Data.localSet("current_verse_hash", hash);
    verse = Lyric.State.current_project.verses[hash];
    typeIndex = Lyric.State.User.typeIndex === "2" ? 1 : Lyric.State.User.typeIndex;
    placeholders = Lyric.config.placeholders[Lyric.config.types[typeIndex]];
    placeholder_text = "";
    if (placeholders != null) {
      placeholder_text = placeholders[Math.floor(Math.random() * placeholders.length)];
    }
    payload = {
      label: "selectVerse",
      verse: verse,
      verses_index: Lyric.State.current_project.verses_index,
      placeholder: placeholder_text
    };
    this.trigger(payload);
    if (!set) {
      Lyric.goto("editor");
    }
    return Velocity.mock = false;
  },
  update: function(content) {
    var command, p;
    if (parseInt(Lyric.State.Account.editor_limit) !== 0 && content.length > Lyric.State.Account.editor_limit) {
      content = content.substr(0, Lyric.State.Account.editor_limit);
      editor_area.blur();
      command = {
        service: "ux",
        action: "open_extra",
        to: "notice_project_limit"
      };
      Lyric.action(command);
    }
    Lyric.State.current_project.verses[Lyric.State.current_verse_hash].content = escape(content);
    ProjectAction.modifiedCurrentProject();
    p = JSON.parse(JSON.stringify(Lyric.State.current_project));
    return DB.updateProject(p);
  },
  updateTitle: function(title) {
    var p, payload;
    Lyric.State.current_project.verses[Lyric.State.current_verse_hash].title = escape(title);
    ProjectAction.modifiedCurrentProject();
    p = JSON.parse(JSON.stringify(Lyric.State.current_project));
    DB.updateProject(p);
    payload = {
      label: "verses_index",
      verses_index: Lyric.State.current_project.verses_index
    };
    return this.trigger(payload);
  },
  add: function() {
    var command, p, project, verse;
    if (parseInt(Lyric.State.Account.verse_limit) !== 0 && Lyric.State.Account.verse_limit <= Lyric.State.current_project.verses_index.length) {
      command = {
        service: "ux",
        action: "open_extra",
        to: "notice_project_limit"
      };
      Lyric.action(command);
      return;
    }
    verse = Data.factory.verse();
    verse.hash = Lyric.generateHash();
    project = Lyric.State.current_project;
    project.verses_index.push(verse.hash);
    project.verses[verse.hash] = verse;
    p = JSON.parse(JSON.stringify(project));
    DB.updateProject(p);
    return VerseAction.select(verse.hash);
  },
  remove: function(hash) {
    var e, i, p, payload, remove, verse, verses, verses_index, _i, _len, _results;
    app.appendChild(list_item_hold_menu);
    list_item_hold_menu.style.display = "none";
    remove = confirm("Are you sure you want to delete this verse? (this cannot be undone)");
    if (remove) {
      verses = Lyric.State.current_project.verses;
      verses_index = Lyric.State.current_project.verses_index;
      _results = [];
      for (i = _i = 0, _len = verses_index.length; _i < _len; i = ++_i) {
        e = verses_index[i];
        if ((e != null) && e === hash) {
          verses_index.splice(i, 1);
          delete verses[e];
          if (verses_index.length === 0) {
            verse = Data.factory.verse();
            verse.hash = Lyric.generateHash();
            Lyric.State.current_project.verses = {};
            Lyric.State.current_project.verses[verse.hash] = verse;
            Lyric.State.current_project.verses_index = [verse.hash];
            verses_index = Lyric.State.current_project.verses_index;
          }
          p = JSON.parse(JSON.stringify(Lyric.State.current_project));
          DB.updateProject(p);
          VerseAction.select(verses_index[verses_index.length - 1], true);
          payload = {
            label: "verses_index",
            verses_index: verses_index
          };
          this.trigger(payload);
          break;
        } else {
          _results.push(void 0);
        }
      }
      return _results;
    }
  },
  toProjectMenu: function() {
    var content;
    if (Lyric.State.current_project.verses[Lyric.State.current_verse_hash].title.length === 0) {
      content = Lyric.State.current_project.verses[Lyric.State.current_verse_hash].content;
      if (content != null) {
        content = unescape(content.substr(0, 15)).trim();
      } else {
        content = "Untitled";
      }
      return VerseAction.updateTitle(content);
    }
  }
});

ReferenceAction = Reflux.createActions(["lookup", "lookup_return"]);

ReferenceStore = Reflux.createStore({
  listenables: ReferenceAction,
  init: function() {},
  lookup: function(word) {
    var command, response;
    command = {
      service: "reference",
      action: "lookup",
      hash: Lyric.State.User.hash,
      word: word
    };
    return response = Sync.request(command, true);
  },
  lookup_return: function(data) {
    data = data.reference;
    return this.trigger(data);
  }
});

Reference = {
  response: {
    lookup: function(data) {
      return ReferenceAction.lookup_return(data);
    }
  }
};


/*

TODO: 
    - store search history 

Project Data Structure

    Project
        hash: "string"
        title: "string"
        modified: "last modified datetime"
        share: "hash if generated, else null"
        trash: [ verses ]
        verses: [ verses ] 
        instr: "encoded string if applicable, else null"

    Verse
        hash: "string"
        title: "string"  -- if left blank, gets set to the first line from content
        content:" string"
 */

Data = {

  /*
  prj_hash:->
      p = @gg()
      p.hash=p.id
  
      ret={}
      ret[p.hash]=p
      for i in [1..15]
          if i == 8
              continue
          proj = Data.factory.project()
          proj.title= "This is a project "+i
          proj.modified= "some date" 
          proj.hash = i
          ret[proj.hash]=proj
      return ret
  projects:->
      p = @gg()
      p.hash=p.id
  
      ret = []
      ret.push p
      for i in [1..15]
          proj = 
              title: "This is a project "+i
              modified: "some date" 
          proj.hash = i
          ret.push proj
      return ret
   */
  project_list: function() {
    var r;
    r = Data.localGet("project_list");
    if (r != null) {
      return JSON.parse(r);
    }
    return [];
  },
  localGet: function(key, d) {
    var r;
    r = localStorage.getItem("lyric_" + key);
    if (r != null) {
      return r;
    }
    return d;
  },
  localSet: function(key, v) {
    return localStorage.setItem("lyric_" + key, v);
  },
  setup: function() {
    var account, iOS, project_list, ua, verse_hash;
    ua = navigator.userAgent.toLowerCase();
    Lyric.State.isAndroid = ua.indexOf("android") > -1;
    Lyric.State.User.hash = Data.localGet("user_hash");
    React.renderComponent(new Layout.lyric({}), document.getElementById("viewport"));
    document.body.classList.add("user_background");
    if (iOS = /(iPad|iPhone|iPod)/g.test(navigator.userAgent)) {
      viewport.classList.add("ios");
    }
    if (Lyric.State.User.hash != null) {
      SyncAction.sync("bootcheck");
      Lyric.State.setCurrentPage("project_list");
      project_list = this.localGet("project_list", []);
      account = Data.localGet("user_account");
      if (account != null) {
        Lyric.State.Account = JSON.parse(account);
        setInterval((function() {
          return SyncAction.syncCheck();
        }), 1000 * 60 * parseInt(Lyric.State.Account.sync_interval));
      }
      UserAction.updateBackground(Data.localGet("user_background", "#1abc9c"));
      UserAction.updateStagename(Data.localGet("user_stagename", "Artist"));
      UserAction.updateType(Data.localGet("user_type", 0));
      Lyric.State.current_project_hash = Data.localGet("current_project_hash");
      if (Lyric.State.current_project_hash != null) {
        Lyric.State.current_project_index = Data.localGet("current_project_index");
        Lyric.Register.set("startup_with_project", true);
        verse_hash = Data.localGet("current_verse_hash");
        if (verse_hash != null) {
          Lyric.State.current_verse_hash = verse_hash;
          Lyric.Register.set("startup_with_verse", true);
        }
        Velocity.mock = true;
        return ProjectAction.select(Lyric.State.current_project_hash, Lyric.State.current_project_index);
      }
    } else {
      Lyric.State.setCurrentPage("user_access_email");
      ExtraPaneAction("user_access");
      return app.style["-webkit-transform"] = "translateX(100%)";
    }
  },
  factory: {
    verse: function() {
      return {
        hash: "1",
        title: "",
        content: ""
      };
    },
    project: function(empty) {
      var v;
      v = {
        1: this.verse()
      };
      if ((empty != null) && empty === "empty") {
        v = {};
      }
      return {
        hash: "",
        trash: [],
        verses: v,
        verses_index: [1],
        title: "Project",
        modified: Date.now(),
        share: null,
        instr: null
      };
    }
  }
};

// Generated by CoffeeScript 1.8.0
var DB;

DB = {
  db: null,
  init: function() {
    var request;
    this.sql = window.indexedDB == null;
    if (!this.sql) {
      request = indexedDB.open("Lyric", 2);
      request.onsuccess = function(event) {
        DB.db = event.target.result;
        Data.setup();
        return DB.db.onerror = function(event) {
          return console.log("Database error: " + event.target.errorCode);
        };
      };
      request.onupgradeneeded = function(event) {
        var db, projectStore;
        console.log("upgrade");
        db = event.target.result;
        projectStore = db.createObjectStore("projects", {
          keyPath: "hash"
        });
        projectStore.createIndex("title", "title", {
          unique: false
        });
        return console.log("done upgrade");
      };
    } else {
      this.db = openDatabase('lyric', '1', 'Projects', 10 * 1024 * 1024);
      this.exec("CREATE TABLE IF NOT EXISTS projects (hash unique,project)");
      return Data.setup();
    }
  },
  addProject: function(project) {
    var projectStore, project_json, request, transaction;
    if (!this.sql) {
      transaction = this.db.transaction(["projects"], "readwrite");
      projectStore = transaction.objectStore("projects");
      request = projectStore.add(project);
      return request.onsuccess = function(event) {
        return console.log("Project ", project.hash, " added");
      };
    } else {
      project_json = JSON.stringify(project);
      return this.exec("insert into projects values (" + project.hash + ",'" + project_json + "')");
    }
  },
  deleteProject: function(project_hash) {
    var projectStore, request, transaction;
    if (!this.sql) {
      transaction = this.db.transaction(["projects"], "readwrite");
      projectStore = transaction.objectStore("projects");
      request = projectStore["delete"](project_hash);
      return request.onsuccess = function(event) {};
    } else {
      return this.exec("delete from projects where hash=" + project_hash);
    }
  },
  getProject: function(project_hash, callback) {
    var db, project, projectStore, request, transaction;
    if (!this.sql) {
      transaction = this.db.transaction(["projects"], "readwrite");
      projectStore = transaction.objectStore("projects");
      project = {};
      request = projectStore.get(project_hash);
      request.onsuccess = function(event) {
        project = request.result;
        return callback(project);
      };
      return true;
    } else {
      db = this.db;
      db.transaction(function(tx) {
        return tx.executeSql("select hash,project from projects where hash=" + project_hash, [], function(tx, results) {
          var row;
          if (results.rows.length > 0) {
            row = results.rows.item(0);
            project = JSON.parse(row.project);
            return callback(project);
          }
        });
      });
      return true;
    }
  },
  updateProject: function(project) {
    var db, projectStore, project_json, request, transaction;
    if (!this.sql) {
      transaction = this.db.transaction(["projects"], "readwrite");
      projectStore = transaction.objectStore("projects");
      request = projectStore.put(project);
      return true;
    } else {
      project_json = JSON.stringify(project);
      db = this.db;
      db.transaction(function(tx) {
        Data.localSet("current_project_json", project_json);
        return tx.executeSql("select hash,project from projects where hash=" + project.hash, [], function(tx, results) {
          if (results.rows.length > 0) {
            return DB.exec("update projects set project='" + project_json + "' where hash=" + project.hash + ";");
          } else {
            return DB.exec("insert into projects values (" + project.hash + ",'" + project_json + "')");
          }
        });
      });
      return true;
    }
  },
  getAll: function(callback) {
    var cursorRequest, db, keyRange, projectStore, projects, transaction;
    projects = [];
    if (!this.sql) {
      transaction = this.db.transaction(["projects"], "readwrite");
      projectStore = transaction.objectStore("projects");
      transaction.oncomplete = function() {
        return callback(projects);
      };
      keyRange = IDBKeyRange.lowerBound(0);
      cursorRequest = projectStore.openCursor(keyRange);
      cursorRequest.onsuccess = function(e) {
        var result;
        result = e.target.result;
        if (!!result === false) {
          return;
        }
        projects.push(result.value);
        return result["continue"]();
      };
    } else {
      db = this.db;
      return db.transaction(function(tx) {
        return tx.executeSql("select hash,project from projects ", [], function(tx, results) {
          var i, project, row, _i, _ref;
          if (results.rows.length > 0) {
            for (i = _i = 0, _ref = results.rows.length - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; i = 0 <= _ref ? ++_i : --_i) {
              row = results.rows.item(i);
              project = JSON.parse(row.project);
              projects.push(project);
            }
          }
          return callback(projects);
        });
      });
    }
  },
  exec: function(sql) {
    var db;
    db = this.db;
    return db.transaction(function(tx) {
      return tx.executeSql(sql);
    });
  },
  deleteDB: function() {
    if (!this.sql) {
      return window.indexedDB.deleteDatabase("Lyric");
    } else {
      return DB.exec("delete from projects");
    }
  }
};

// Generated by CoffeeScript 1.8.0
var Sync, SyncAction, SyncStore;

SyncAction = Reflux.createActions(["sync", "syncDone", "addBetaNote", "syncCheck", "syncError"]);

SyncStore = Reflux.createStore({
  listenables: SyncAction,
  Status: {},
  syncError: function() {
    var payload;
    this.Status = payload = {
      syncing: 2,
      sync_status: "Hmmmm, are you connected to the internet?"
    };
    this.trigger(payload);
    project_list_footer_sync.children[1].classList.add("error");
    return project_list_footer_sync.children[1].classList.remove("fa-spin");
  },
  sync: function(action, type) {
    var payload, projects, user;
    if (type == null) {
      type = action;
    }
    Data.localSet("last_synced", Date.now());
    project_list_footer_sync.children[1].classList.remove("error");
    project_list_footer_sync.children[1].classList.add("fa-spin");
    this.Status = payload = {
      syncing: 1,
      sync_status: "Syncing"
    };
    this.trigger(payload);
    projects = {};
    Data.project_list().map(function(i) {
      if (i != null) {
        return projects[i[0]] = i[2];
      }
    });
    user = Lyric.State.User;
    user.account = null;
    payload = {
      service: "sync",
      action: action,
      type: type,
      hash: Lyric.State.User.hash,
      user: user,
      device: navigator.userAgent,
      beta_notes: Data.localGet("beta_notes", null),
      delete_log: Data.localGet("delete_log", null),
      projects: JSON.stringify(projects)
    };
    Sync.payload = payload;
    return DB.getAll(Sync.fillHold);
  },
  syncCheck: function() {
    var current, last;
    last = parseInt(Data.localGet("last_synced"));
    current = Date.now();
    if (last + 60000 * Lyric.State.Account.sync_interval <= current) {
      return this.sync("bootcheck", "auto_sync");
    }
  },
  syncDone: function() {
    var payload, type;
    project_list_footer_sync.children[1].classList.remove("fa-spin");
    this.Status = payload = {
      project_list: Data.project_list(),
      syncing: 0,
      sync_status: "Last Synced " + (new Date().toLocaleString())
    };
    type = Sync.payload.type;
    Sync.payload = {};
    Data.localSet("beta_notes", JSON.stringify([]));
    Data.localSet("delete_log", JSON.stringify([]));
    if (type === "login") {
      app.style["-webkit-transform"] = "translateX(0%)";
    }
    return this.trigger(payload);
  },
  addBetaNote: function() {
    var beta_note, list;
    beta_note = beta_textarea.value;
    beta_textarea.value = "";
    list = JSON.parse(Data.localGet("beta_notes"));
    if (list == null) {
      list = [];
    }
    list.push(beta_note);
    Data.localSet("beta_notes", JSON.stringify(list));
    return alert("Thank You. Your note will be sent on next sync");
  }
});

Sync = {
  version: 1,
  "package": {
    user_hash: "asdfa",
    commands: []
  },
  start: function() {},
  check_all: function() {},
  check: function() {},
  checkEmail: function(email) {
    return true;
  },

  /*
      Called by components to add their request to the next package to be sent
      command:
          service
          action
          args
   */
  queue_request: function(command) {
    console.log(command);
    return this["package"].commands.push(command);
  },

  /*
      Completes an ajax request with the given command
   */
  request: function(command) {
    try {
      return qwest.before(function() {
        return this.onreadystatechange = function() {
          if (this.status === 0) {
            return Sync.error(command);
          }
        };
      }).post(Lyric.config.api_url, command, {
        retries: 1
      }).then(function() {
        return Sync.response(this.response);
      })["catch"](function() {
        this.response_error = true;
        return Sync.response(this.response);
      });
    } catch (_error) {}
  },

  /*
      processes responses from server
   */
  response: function(pkg) {
    var payload;
    if (typeof pkg === "string") {
      pkg = JSON.parse(pkg);
    }
    payload = pkg.data;
    payload.response = true;
    if (payload.ctrl != null) {
      Lyric.ctrl(payload);
      return;
    }
    if (payload.service === "sync") {
      Sync[payload.action](payload);
    } else {
      Lyric.action(payload);
    }
    return Lyric.State.indicator = payload.indicator;
  },
  error: function(payload) {
    payload.error = true;
    if (payload.service === "sync") {
      return SyncAction.syncError();
    } else {
      return Lyric.action(payload);
    }
  },
  payload: {},
  projects_hold: {},
  updateUserInfo: function(payload) {
    var user;
    if (payload.userinfo != null) {
      user = payload.userinfo;
      UserAction.updateType(user.art_type);
      UserAction.updateStagename(user.stagename);
      UserAction.updateBackground(user.color);
      Lyric.State.User.hash = user.hash;
      Data.localSet("user_hash", user.hash);
      Lyric.State.Account = user.account;
      Data.localSet("user_account", JSON.stringify(user.account));
      return payload.hash = user.hash;
    }
  },
  apprentist: function(payload) {
    this.updateUserInfo(payload);
    return SyncAction.syncDone();
  },
  fillHold: function(projects) {
    var payload;
    Sync.projects_hold = {};
    projects.map(function(i) {
      return Sync.projects_hold[i.hash] = i;
    });
    payload = Sync.payload;
    Sync.request(payload);
    return Sync.payload = {};
  },
  syncing: function(payload) {
    var send_project, send_project_hash;
    this.updateUserInfo(payload);
    this.updateProject(payload.trans_project_hash, payload.trans_project);
    if (payload.need != null) {
      send_project_hash = payload.need.pop();
      if (send_project_hash != null) {
        send_project = Sync.projects_hold[parseInt(send_project_hash)];
        payload.trans_project_hash = send_project_hash;
        payload.trans_project = send_project;
      }
    }
    if (((payload.need != null) && payload.need.length > 0) || ((payload.give != null) && payload.give.length > 0) || (payload.trans_project != null)) {
      return Sync.request(payload);
    } else {
      Sync.payload = payload;
      return DB.getAll(this.buildProjectList);
    }
  },
  sendProject: function(payload) {},
  buildProjectList: function(projects) {
    var not_inserted, project_list;
    project_list = Data.localGet("project_list");
    not_inserted = [];
    project_list = projects.map(function(project) {
      return [project.hash, project.title, project.modified];
    });
    Data.localSet("project_list", JSON.stringify(project_list));
    return SyncAction.syncDone();
  },
  updateProject: function(hash, project) {
    if (hash == null) {
      return;
    }
    project.hash = parseInt(project.hash);
    project.modified = parseInt(project.modified);
    return DB.updateProject(project);
  }
};

// Generated by CoffeeScript 1.8.0
Layout.editor = React.createClass({
  mixins: [Reflux.listenTo(VerseStore, "updateEditor")],
  getInitialState: function() {
    return {
      title: "",
      content: "",
      placeholder: "",
      touch_origin: [-1, -1]
    };
  },
  updateEditor: function(payload) {
    switch (payload.label) {
      case "selectVerse":
        return this.setState({
          title: unescape(payload.verse.title),
          content: unescape(payload.verse.content),
          placeholder: payload.placeholder
        });
    }
  },
  handleTextAreaChange: function(event) {
    var content;
    content = event.target.value;
    this.setState({
      content: content
    });
    return VerseAction.update(content);
  },
  handleTitleChange: function(event) {
    var title;
    title = event.target.value;
    if (title.length > 15) {
      title = title.substr(0, 15);
    }
    this.setState({
      title: title
    });
    return VerseAction.updateTitle(title);
  },
  onTouchStart: function(e) {
    var touch;
    touch = e.touches[0];
    return this.state.touch_origin = [e.touches[0].clientX, e.touches[0].clientY];
  },
  onTouchMove: function(e) {
    var touch_offset, x;
    touch_offset = [e.touches[0].clientX - this.state.touch_origin[0], this.state.touch_origin[1] - e.touches[0].clientY];
    Lyric.osTouchMove(e, touch_offset);
    x = touch_offset[0];
    switch (Lyric.State.getCurrentPage()) {
      case "project_menu":
        if (x < -50) {
          this.state.touch_origin = [e.touches[0].clientX, e.touches[0].clientY];
          return Lyric.goto("editor");
        }
        break;
      case "editor":
        if (x > 100) {
          this.state.touch_origin = [e.touches[0].clientX, e.touches[0].clientY];
          return Lyric.goto("project_menu");
        }
    }
  },
  onTouchEnd: function(e) {},
  onFocus: function() {
    if (!Lyric.State.isAndroid) {
      return editor.style.marginTop = "15px";
    }
  },
  onBlur: function() {
    if (!Lyric.State.isAndroid) {
      return editor.style.marginTop = "0px";
    }
  },
  render: function() {
    return React.DOM.div({
      id: "editor",
      onTouchMove: this.onTouchMove,
      onTouchEnd: this.onTouchEnd,
      onTouchStart: this.onTouchStart
    }, React.DOM.div({
      id: "editor_header",
      className: "toolbar"
    }, Button.get("editor_header_menu"), React.DOM.div({}, UI.textfield("editor_header_verse_title", {
      value: this.state.title,
      onChange: this.handleTitleChange
    })), Button.get("editor_header_search")), React.DOM.textarea({
      id: "editor_area",
      placeholder: this.state.placeholder,
      value: this.state.content,
      onChange: this.handleTextAreaChange,
      onFocus: this.onFocus,
      onBlur: this.onBlur
    }), Layout.editor_activator);
  }
});

Layout.editor_activator = React.DOM.div({
  id: "editor_activator",
  onClick: function() {
    if (Lyric.State.getCurrentPage() === "project_menu") {
      return Lyric.goto("editor");
    }
  }
});

// Generated by CoffeeScript 1.8.0
var ExtraPaneAction;

Layout.lyric = React.createClass({
  render: function() {
    var extra_pane, list_item_hold_menu, lyric_workspace, new_user_introduction, project_list;
    extra_pane = new Layout.extra_pane({});
    project_list = new Layout.project_list({});
    lyric_workspace = new Layout.lyric_workspace({});
    new_user_introduction = new Layout.new_user_introduction({});
    list_item_hold_menu = new UI.list_item_hold_menu({});
    return React.DOM.div({
      id: "app"
    }, extra_pane, project_list, lyric_workspace, React.DOM.li({
      id: "list_placeholder"
    }), React.DOM.div({
      id: "list_item_hold_indicator"
    }), new_user_introduction, list_item_hold_menu);
  }
});

Layout.lyric_workspace = React.createClass({
  mixins: [Reflux.listenTo(ProjectStore, "retrieved_project")],
  getInitialState: function() {
    return {
      open: false,
      current_height: 60,
      project_hash: "",
      project: null
    };
  },
  retrieved_project: function(payload) {
    if (payload.project != null) {
      return this.setState({
        project: payload.project
      });
    }
  },
  render: function() {
    var editor, menu, search;
    console.log(this.state.project, "!");
    if (this.state.project != null) {
      editor = Layout.editor({});
      search = Layout.search({});
      menu = Layout.project_menu({
        project_title: this.state.project.title,
        share_hash: this.state.project.share
      });
      return React.DOM.div({
        id: "lyric_workspace",
        className: "bar user_background",
        style: {
          background: Lyric.State.User.background
        }
      }, React.DOM.div({
        id: "lyric_workspace_container"
      }, menu, editor, search));
    } else {
      return React.DOM.div({
        id: "lyric_workspace",
        className: "bar"
      });
    }
  }
});

ExtraPaneAction = Reflux.createAction();

Layout.extra_pane = React.createClass({
  componentDidMount: function() {
    return this.unsubscribe = ExtraPaneAction.listen(this.set);
  },
  componentWillUnmount: function() {
    return this.unsubscribe();
  },
  getInitialState: function() {
    return {
      layout: "user_access"
    };
  },
  set: function(layout) {
    if (layout === "lyric_hub") {
      Lyric.State.indicator = false;
    }
    return this.setState({
      layout: layout
    });
  },
  render: function() {
    var body;
    if (this.state.layout != null) {
      body = window["Layout"][this.state.layout]({});
    } else {
      body = React.DOM.span({}, "!!!!");
    }
    return React.DOM.div({
      id: "extra_pane_container",
      className: "user_background",
      style: {
        background: Lyric.State.User.background
      }
    }, body);
  }
});

Layout.beta_feedback = React.createClass({
  render: function() {
    return React.DOM.div({
      id: "beta_feedback"
    }, React.DOM.div({
      className: "header"
    }, Button.get("close_beta")), React.DOM.div({
      className: "body"
    }, React.DOM.div({
      className: "center_text white"
    }, React.DOM.div({
      className: "lead"
    }, "Any Issues or ideas?"), " Your feedback helps create a better experience ", React.DOM.textarea({
      id: "beta_textarea"
    }), Button.get("beta_feedback_send", {
      onclick: SyncAction.addBetaNote
    }))));
  }
});

Layout.settings = React.createClass({
  render: function() {
    return React.DOM.div({
      id: "settings"
    }, React.DOM.div({
      className: "header"
    }, Button.get("back_from_extra"), React.DOM.span({
      className: "lead white"
    }, "Settings")), React.DOM.div({
      className: "body"
    }, UI.settings_pane({
      levels: Lyric.config.lyric_settings
    })));
  }
});

Layout.transcript = React.createClass({
  mixins: [Reflux.listenTo(ProjectStore, "transcript_view")],
  getInitialState: function() {
    return {
      project: {}
    };
  },
  transcript_view: function(payload) {
    if (payload.label !== "transcript") {
      return;
    }
    return this.setState({
      project: payload.project
    });
  },
  render: function() {
    var elements, project, title;
    project = Lyric.State.current_project;
    title = project.title;
    console.log(project);
    elements = [];
    project.verses_index.map(function(i) {
      var verse;
      verse = project.verses[i];
      elements.push(React.DOM.li({
        className: "verse_title"
      }, unescape(verse.title)));
      return elements.push(React.DOM.li({
        className: "verse_content"
      }, unescape(verse.content.replace(/\r?\n/g, '<br/>'))));
    });
    return React.DOM.div({
      id: "transcript"
    }, React.DOM.div({
      className: "header"
    }, Button.get("back_from_extra"), React.DOM.span({
      className: "lead white"
    }, title)), React.DOM.div({
      className: "body"
    }, React.DOM.ul({}, elements)));
  }
});

Layout.notice_project_limit = React.createClass({
  render: function() {
    return React.DOM.div({
      id: "notice_project_limit"
    }, React.DOM.div({
      className: "header"
    }, Button.get("back_from_extra"), React.DOM.span({
      className: "lead white"
    }, "Notice")), React.DOM.div({
      className: "body center_text white"
    }, React.DOM.h3({}, "You're so close!"), React.DOM.p({
      className: "lead"
    }, "Please verify your email address to take full advantage of Lyric"), React.DOM.p({}, "Check your email for an verification link from us.")));
  }
});

Layout.lyric_hub = React.createClass({
  render: function() {
    return React.DOM.div({
      id: "lyric_hub"
    }, React.DOM.div({
      className: "header"
    }, Button.get("back_from_extra"), React.DOM.span({
      className: "lead white"
    }, "Lyric HUB")), React.DOM.div({
      className: "body"
    }, React.DOM.div({
      id: "lyric_hub_body"
    }, "Loding Lyric Hub", React.DOM.i({
      className: "fa fa-spinner fa-spin"
    })), React.DOM.div({
      id: "iFrame_container"
    }, React.DOM.iframe({
      src: "http://lyricapp.me/hub.php?u=" + Lyric.State.User.hash
    }))));
  }
});

Layout.action_disabled = React.DOM.div({}, "Roses are red on boats that sail. To begin an adventure verify your email.");

// Generated by CoffeeScript 1.8.0
Layout.new_user_introduction = React.createClass({
  mixins: [Reflux.listenTo(NUIStore, "update")],
  update: function(payload) {
    if (payload != null) {
      return this.setState(payload);
    }
  },
  getInitialState: function() {
    return {
      visible: false,
      heading: "Test",
      sub_text: "sub text",
      blurbY: 100,
      focusOrigin: [0, 0],
      page: 0,
      focus: [0, 0, 100, 100],
      overlay_config: null,
      show_next: false,
      passthrough: false,
      allow_full_passthrough: false,
      done: false
    };
  },
  render: function() {
    var doneElements, passthrough;
    passthrough = this.state.passthrough;
    doneElements = [];
    if (this.state.done) {
      doneElements.push(React.DOM.div({
        id: "nui_replay",
        className: "button",
        onClick: function() {
          return NUIActions.start();
        }
      }, "Replay?"));
      doneElements.push(React.DOM.br());
      doneElements.push(React.DOM.div({
        id: "nui_finish",
        className: "button",
        onClick: function() {
          return NUIActions.finish();
        }
      }, "Let me WRITE!"));
    } else if (this.state.page === 0) {
      doneElements.push(React.DOM.div({
        id: "nui_finish",
        className: "",
        onClick: function() {
          return NUIActions.finish();
        }
      }, "Skip"));
    }
    return React.DOM.div({
      id: "new_user_introduction",
      style: !this.state.visible ? {
        display: "none"
      } : void 0
    }, React.DOM.div({
      id: "nui_overlay"
    }, this.state.overlay_config != null ? this.state.overlay_config.map(function(i) {
      return React.DOM.div({
        className: "",
        style: {
          "-webkit-transform": "translate3D(" + i[1] + "," + i[0] + ",0)",
          height: i[2],
          width: i[3]
        }
      });
    }) : void 0, React.DOM.div({
      className: "focus " + (this.state.allow_full_passthrough ? "passthrough" : void 0),
      onClick: function() {
        if (!passthrough) {
          return NUIActions.actionNext();
        }
      },
      style: {
        "-webkit-transform": "translate3D(" + this.state.focus[1] + "px," + this.state.focus[0] + "px,0)",
        height: this.state.focus[2] + "px",
        width: this.state.focus[3] + "px"
      }
    })), React.DOM.div({
      id: "nui_blurb",
      className: "user_background",
      style: {
        "-webkit-transform": "translateY(" + this.state.blurbY + "px)"
      }
    }, React.DOM.h3({}, this.state.heading), React.DOM.h4({}, this.state.sub_text), React.DOM.div({
      id: "nui_next",
      className: "button",
      onClick: function() {
        return NUIActions.next();
      },
      style: !this.state.show_next ? {
        display: "none"
      } : void 0
    }, "Next"), doneElements));
  }
});

// Generated by CoffeeScript 1.8.0
Layout.project_list = React.createClass({
  mixins: [Reflux.listenTo(ProjectStore, "create"), Reflux.listenTo(SyncStore, "update")],
  getInitialState: function() {
    return {
      scroll_header_enabled: false,
      last_scroll_y: 0,
      scrolling_up: false,
      projects: Data.project_list(),
      projects_showing: []
    };
  },
  backToTop: function() {
    return project_list_container.scrollTop = 0;
  },
  update: function(payload) {
    if (payload.project_list != null) {
      return this.setState({
        projects: payload.project_list
      });
    }
  },
  scrollEvent: function(e) {
    var toolbar;
    toolbar = project_list_search;
    if (!this.state.scroll_header_enabled && e.target.scrollTop >= toolbar.offsetTop + toolbar.clientHeight) {
      this.state.scroll_header_enabled = true;
    } else if (this.state.scroll_header_enabled && e.target.scrollTop < toolbar.offsetTop) {
      this.state.scroll_header_enabled = false;
      this.scroll_header(false);
    }
    if (this.state.scroll_header_enabled) {
      if (!this.state.scrolling_up && this.state.last_scroll_y > e.target.scrollTop) {
        this.state.scrolling_up = true;
        this.scroll_header(true);
      } else if (this.state.scrolling_up && this.state.last_scroll_y < e.target.scrollTop) {
        this.state.scrolling_up = false;
        this.scroll_header(false);
      }
    }
    if (Math.abs(this.state.last_scroll_y - project_list_container.scrollTop) !== 0) {
      Lyric.killHoldMenu();
    }
    return this.state.last_scroll_y = e.target.scrollTop;
  },
  scroll_header: function(show) {
    var f, h;
    h = project_list_scroll_header.classList;
    f = project_list_footer.classList;
    if (show) {
      h.remove("hide");
      return h.add("show");
    } else {
      h.remove("show");
      return h.add("hide");
    }
  },
  create_project: function() {
    var date, title;
    title = project_list_add_title.value;
    project_list_add_title.value = "";
    if (title.length === 0) {
      date = new Date();
      date = date.toDateString();
      project_list_add_title.value = date;
    } else {
      ProjectAction.create(title);
    }
  },
  create: function(payload) {
    if (payload.label === "project_list") {
      return this.setState({
        projects: payload.data
      });
    }
  },
  filter_list: function(e) {
    var p_l, query;
    query = project_list_search.value.toLowerCase();
    p_l = [];
    this.state.projects.map(function(entry) {
      if (entry[1].toLowerCase().indexOf(query) !== -1) {
        return p_l.push(entry);
      }
    });
    return this.setState({
      projects_showing: p_l
    });
  },
  render: function() {
    var proj_list, projects;
    projects = this.state.projects_showing.length === 0 ? this.state.projects : this.state.projects_showing;
    proj_list = projects.map(function(entry, y) {
      var hash, i, title;
      hash = entry[0];
      title = entry[1];
      i = {
        title: title,
        last_mod: "",
        hash: hash,
        key: hash,
        view: true,
        "delete": true,
        id_start: "project",
        click_command: function() {
          return ProjectAction.select(i.hash, y);
        },
        delete_onclick: function() {
          return ProjectAction.remove(i.hash);
        },
        options: [
          {
            label: "Full View",
            icon: "fa-eye",
            click: function() {
              ProjectAction.transcript(hash);
              return UIActions.hideHoldMenu();
            }
          }
        ]
      };
      return UI.list_item(i);
    });
    if (proj_list.length === 0) {
      proj_list = React.DOM.div({
        id: "empty_project"
      }, "touch the ", React.DOM.i({
        className: "fa fa-plus"
      }), " to get started");
    }
    return React.DOM.div({
      id: "project_list_main_container"
    }, React.DOM.div({
      id: "project_list_add_container",
      className: "user_background white center_text",
      style: {
        background: Lyric.State.User.background
      }
    }, UI.textfield("project_list_add_title", {
      className: "white"
    }), Button.get("new_project_create", {
      onclick: this.create_project
    })), React.DOM.div({
      id: "project_list_container",
      className: "user_background",
      onScroll: this.scrollEvent,
      onTouchStart: this.scrollEvent
    }, Layout.project_list.header({}), Layout.project_list.greeting({}), React.DOM.div({
      id: "project_list_search_container"
    }, UI.textfield("project_list_search", {
      onChange: this.filter_list
    })), React.DOM.ul({
      id: "project_list_list",
      className: "list"
    }, proj_list)), React.DOM.div({
      id: "project_list_scroll_header",
      className: "hide"
    }, React.DOM.div({
      className: "logo"
    }), React.DOM.div({
      id: ""
    }, Button.get("project_list_backToTop", {
      onclick: this.backToTop
    }))), React.DOM.div({
      id: "project_list_footer",
      className: "hide user_background"
    }, UI.toolbar("project_list_footer_toolbar")), Layout.project_list_overlay({}));
  }
});

Layout.project_list_overlay = React.createClass({
  render: function() {
    return React.DOM.div({
      id: "project_list_overlay",
      className: "overlay lead center_text white",
      onClick: function() {
        var command;
        command = {
          service: "lyric",
          action: "gotoCommand",
          to: "project_list"
        };
        return Lyric.action(command);
      }
    }, "Touch anywhere here to cancel");
  }
});

Layout.project_list.greeting = React.createClass({
  mixins: [Reflux.listenTo(UserStore, "update")],
  getInitialState: function() {
    return {
      stagename: "",
      type: "Music"
    };
  },
  update: function(payload) {
    switch (payload.label) {
      case "stagename":
        return this.setState({
          stagename: payload.name
        });
      case "type":
        return this.setState({
          type: payload.type
        });
    }
  },
  render: function() {
    return React.DOM.div({
      id: "project_list_greeting",
      className: "white"
    }, React.DOM.div({
      id: "greeting_stagename",
      className: "lead"
    }, this.state.stagename), React.DOM.h3({
      className: ""
    }, "hey,"), React.DOM.div({
      id: "greeting_prompt",
      className: "lead"
    }, "let's write some", React.DOM.span({
      id: "greeting_prompt_type"
    }, this.state.type, "!")), React.DOM.span({
      id: "stagename_scale"
    }));
  }
});

Layout.project_list.header = React.createClass({
  render: function() {
    var show_indicator;
    show_indicator = Lyric.State.indicator ? "" : " invisible";
    return React.DOM.div({
      id: "project_list_header",
      className: "toolbar white"
    }, React.DOM.div({
      id: "project_list_branding",
      onClick: function() {
        var command;
        command = {
          service: "ux",
          action: "open_extra",
          to: "lyric_hub"
        };
        return Lyric.action(command);
      }
    }, React.DOM.div({
      className: "logo"
    }), React.DOM.i({
      className: "fa fa-exclamation-circle" + show_indicator
    })), Button.get("new_project"));
  }
});

Layout.sync_center = React.createClass({
  mixins: [Reflux.listenTo(SyncStore, "update")],
  getInitialState: function() {
    return {
      hero_spinning: false,
      show_error: false,
      sync_status: "Nothing to Sync"
    };
  },
  update: function(payload) {
    var hero_spinning, show_error;
    console.log(payload);
    if (payload.syncing != null) {
      hero_spinning = payload.syncing === 1;
      show_error = payload.syncing === 2;
    }
    return this.setState({
      hero_spinning: hero_spinning,
      show_error: show_error,
      sync_status: payload.sync_status
    });
  },
  componentDidMount: function() {
    return this.update(SyncStore.Status);
  },
  render: function() {
    var hero_spin, icon, upgrade;
    upgrade = [];
    if (this.state.show_error) {
      icon = React.DOM.span({
        className: "fa-stack "
      }, React.DOM.i({
        className: "fa fa-refresh fa-stack-1x"
      }), React.DOM.i({
        className: "fa fa-ban fa-stack-1x text-danger"
      }));
    } else {
      hero_spin = this.state.hero_spinning ? "fa-spin" : "";
      icon = React.DOM.i({
        className: "fa fa-refresh " + hero_spin
      });
    }
    return React.DOM.div({
      id: "sync_center"
    }, React.DOM.div({
      className: "header"
    }, Button.get("back_from_extra"), React.DOM.span({
      className: "lead white"
    }, "Sync Center")), React.DOM.div({
      className: "body"
    }, React.DOM.div({
      id: "sync_hero"
    }, icon), React.DOM.div({
      id: "sync_status",
      className: "center_text"
    }, this.state.sync_status), Button.get("sync_now", {
      onclick: (function() {
        return SyncAction.sync("bootcheck", "manual_sync");
      })
    })));
  }
});

// Generated by CoffeeScript 1.8.0
Layout.project_menu = React.createClass({
  mixins: [Reflux.listenTo(ProjectStore, "update")],
  getInitialState: function() {
    return {
      project_title: this.props.project_title
    };
  },
  update: function(payload) {
    if (payload.project != null) {
      this.setState({
        project_title: payload.project.title
      });
    }
    if (payload.updated_title != null) {
      this.setState({
        project_title: payload.updated_title
      });
    }
    return console.log("update project menu");
  },
  updateTitle: function() {
    return ProjectAction.updateTitle(project_title_input.value);
  },
  setTitle: function() {
    return ProjectAction.saveUpdatedTitle(project_title_input.value);
  },
  render: function() {
    return React.DOM.div({
      id: "project_menu_container"
    }, React.DOM.div({
      id: "project_menu_header",
      className: "toolbar white"
    }, Button.get("back_to_project_list"), this.state.project_title), UI.toolbar("project_menu_toolbar"), UI.toolbar("project_menu_footer_toolbar"), React.DOM.div({
      id: "project_menu_body"
    }, React.DOM.div({
      id: "project_menu_body_container"
    }, React.DOM.div({
      className: "drag_bg user_background"
    }), React.DOM.div({
      id: "drag_prompt",
      className: "lead white center_text"
    }, "Sort by dragging arrows below", Button.get("done_sorting")), Layout.project_menu_body_verses({
      verse_list: this.props.verse_list
    }), React.DOM.div({
      id: "project_menu_body_settings"
    }, React.DOM.h4({
      className: "white"
    }, "Project Title"), UI.textfield("project_title_input", {
      defaultValue: this.state.project_title,
      onChange: this.updateTitle
    })), Layout.project_menu_body_info({
      share_hash: this.props.share_hash
    }))));
  }
});

Layout.project_menu_body_info = React.createClass({
  mixins: [Reflux.listenTo(ProjectStore, "update")],
  getInitialState: function() {
    return {
      share_hash: this.props.share_hash
    };
  },
  update: function(payload) {
    var share;
    if (payload.project != null) {
      share = payload.project.share;
      if (share != null) {
        return this.setState({
          share_hash: share
        });
      } else {
        return this.setState({
          share_hash: ""
        });
      }
    }
  },
  shareLink: function() {
    return Lyric.config.share_url + this.state.share_hash;
  },
  render: function() {
    var body, fb_share, social, twitter_share;
    body = [];
    if (parseInt(Lyric.State.Account.aId) !== 2) {
      body.push(Layout.action_disabled);
    } else {
      if ((this.state.share_hash != null) && this.state.share_hash.length > 0) {
        fb_share = "https://www.facebook.com/sharer/sharer.php?u=";
        twitter_share = "https://twitter.com/intent/tweet?original_referer=http%3A%2F%2Flocalhost%2Flyric%2Fdevelop%2F3%2Flive%2Fapp%2F&text=TITLE&tw_p=tweetbutton&url=http%3A%2F%2Flyricapp.me";
        body.push(React.DOM.p({}, "Copy the link from the textfield below and share it!"));
        body.push(React.DOM.input({
          type: "text",
          onClick: function(e) {
            return e.target.select();
          },
          value: this.shareLink()
        }));
        body.push(Button.get("generate_share_hash_undo", {
          className: "roundBtn",
          onclick: function() {
            return ProjectStore.unShareHash();
          }
        }));
        social = [];
        social.push(React.DOM.a({
          className: "share_link",
          href: fb_share + this.shareLink(),
          id: "share facebook",
          target: "_blank"
        }, React.DOM.i({
          className: "fa fa-facebook-square"
        }), React.DOM.div({}, "Share On Facebook")));
        social.push(React.DOM.a({
          className: "share_link",
          href: "https://twitter.com/share",
          target: "_blank"
        }, React.DOM.i({
          className: "fa fa-twitter-square"
        }), React.DOM.div({}, "Share On Twitter")));
      } else {
        body.push(React.DOM.p({}, "Click the Generate button below to begin"));
        body.push(Button.get("generate_share_hash", {
          className: "roundBtn",
          onclick: function() {
            return ProjectStore.createShareHash();
          }
        }));
      }
    }
    return React.DOM.div({
      id: "project_menu_body_info",
      className: "center_text user_background white",
      style: {
        background: Lyric.State.User.background
      }
    }, React.DOM.div({
      id: "project_menu_body_info_container"
    }, React.DOM.h6({}, "Share Your Project"), body));
  }
});

Layout.project_menu_body_verses = React.createClass({
  mixins: [Reflux.listenTo(VerseStore, "update"), Reflux.listenTo(UIStore, "update")],
  getInitialState: function() {
    return {
      selected: "",
      verses_index: [],
      verse_list: []
    };
  },
  update: function(payload) {

    /*
    switch payload.label
        when "selectVerse"
            console.log payload
            @setState({ 
                selected: payload.verse.hash 
                verses_index: payload.verses_index
            })
        when "verses_index"
            @setState({ verses_index: payload.verses_index })
     */
    var selected, verse_list;
    if (payload.verses_index != null) {
      selected = payload.verse ? payload.verse.hash : null;
      verse_list = payload.verses_index.map(function(k) {
        var i;
        i = Lyric.State.current_project.verses[k];
        if (i == null) {
          return;
        }
        i.key = i.hash;
        i.id_start = "verse";
        i.click_command = function() {
          return VerseStore.select(i.hash);
        };
        i.options = [
          {
            label: "Sort",
            icon: "fa-list",
            click: function() {
              return UIActions.startSorting(window[i.id_start + "_" + i.hash]);
            }
          }
        ];
        if (selected != null) {
          i.className = i.hash === selected ? "selected" : "";
        }
        i.delete_onclick = function() {
          return VerseStore.remove(i.hash);
        };
        return UI.list_item(i);
      });
      return this.setState({
        verse_list: verse_list
      });
    }
  },
  project_select: function(payload) {
    switch (payload.label) {
      case "project":
        payload.label = "verse_list";
        payload.verses_index = payload.project.verses_index;
        return this.update(payload);
    }
  },
  render: function() {
    return React.DOM.div({
      id: "project_menu_body_verses"
    }, React.DOM.ul({
      className: "list",
      id: "project_menu_body_verses_ul"
    }, this.state.verse_list));
  }
});

// Generated by CoffeeScript 1.8.0
Layout.search = React.createClass({
  mixins: [Reflux.listenTo(ReferenceStore, "lookup_return")],
  getInitialState: function() {
    return {
      data: null,
      build: [],
      found: null,
      current: 0,
      looking: false,
      show_to_top: false,
      word: ""
    };
  },
  viewSection: function(section) {
    if (this.state.current === 0) {
      return this.setState({
        current: section
      });
    } else {
      return this.setState({
        current: 0
      });
    }
  },
  scrollToTop: function() {
    return search_body.scrollTop = 0;
  },
  lookup_return: function(data) {
    var build, dictionary_list, found, synonym_list, synonym_total;
    if (typeof do_search !== "undefined" && do_search !== null) {
      do_search.classList.remove("fa-spin");
    }
    found = null;
    if (data.defs.length === 0 && data.syns.length === 0) {
      found = false;
    } else {
      build = [];
      dictionary_list = [];
      data.defs.map(function(e) {
        var entries, pos;
        pos = React.DOM.li({
          className: "pos"
        }, e.pos);
        dictionary_list.push(pos);
        return entries = e.def.map(function(def) {
          var d;
          d = React.DOM.li({
            className: "entry"
          }, def);
          return dictionary_list.push(d);
        });
      });
      build.dictionary_list = dictionary_list;
      build.dictionary_total = data.defs.length;
      synonym_list = [];
      synonym_total = 0;
      data.syns.map(function(e) {
        var entries, pos;
        pos = React.DOM.li({
          className: "pos"
        }, e.pos);
        synonym_list.push(pos);
        return entries = e.entry.split(",").map(function(ent, i) {
          var t;
          t = React.DOM.li({
            className: "entry"
          }, ent.trim());
          synonym_list.push(t);
          return synonym_total++;
        });
      });
      build.synonym_list = synonym_list;
      build.synonym_total = synonym_total;
    }
    return this.setState({
      found: found,
      data: data,
      looking: false,
      build: build
    });
  },
  lookup: function(e) {
    e.preventDefault();
    this.setState({
      looking: true
    });
    do_search.classList.add("fa-spin");
    return ReferenceAction.lookup(search_query.value);
  },
  queryUpdate: function() {
    if (search_query.value !== this.state.word) {
      return this.setState({
        word: search_query.value,
        found: null,
        data: null,
        current: 0
      });
    }
  },
  scrollEvent: function(e) {
    if (e.target.scrollTop >= 50) {
      return this.setState({
        show_to_top: true
      });
    } else {
      return this.setState({
        show_to_top: false
      });
    }
  },
  render: function() {
    var body, data, dictionary_section, list, rhyme_close, rhyme_eh, rhyme_list, rhyme_section, scrollToTop, synonym_section, tip, view, viewSection;
    viewSection = this.viewSection;
    scrollToTop = this.scrollToTop;
    if (parseInt(Lyric.State.Account.aId) !== 2) {
      body = Layout.action_disabled;
    } else if (this.state.found != null) {
      body = React.DOM.div({
        id: "search_not_found"
      }, "Couldn't find anything for " + search_query.value);
    } else if (this.state.data != null) {
      data = this.state.data;
      if (this.state.current !== 0) {
        view = {
          dictionary: this.state.current === 1 ? "active" : "inactive",
          synonym: this.state.current === 2 ? "active" : "inactive",
          rhyme: this.state.current === 3 ? "active" : "inactive"
        };
      } else {
        view = {
          dictionary: "section_select",
          synonym: "section_select",
          rhyme: "section_select"
        };
      }
      tip = {
        dictionary: this.state.current === 1 ? React.DOM.i({
          className: "right fa fa-angle-up"
        }) : React.DOM.span({
          className: "right"
        }, this.state.build.dictionary_total),
        synonym: this.state.current === 2 ? React.DOM.i({
          className: "right fa fa-angle-up"
        }) : React.DOM.span({
          className: "right"
        }, this.state.build.synonym_total),
        rhyme: this.state.current === 3 ? React.DOM.i({
          className: "right fa fa-angle-up"
        }) : React.DOM.span({
          className: "right"
        }, data.rhymes.close.length)
      };
      dictionary_section = React.DOM.div({
        id: "reference_dictionary_section",
        className: "reference_section " + view.dictionary
      }, React.DOM.h4({
        className: "section_head",
        onClick: function() {
          return viewSection(1);
        }
      }, "Dictionary", tip.dictionary), this.state.build.dictionary_list);
      synonym_section = React.DOM.div({
        id: "reference_synonym_section",
        className: "reference_section " + view.synonym
      }, React.DOM.h4({
        className: "section_head",
        onClick: function() {
          return viewSection(2);
        }
      }, "Synonyms", tip.synonym), this.state.build.synonym_list);
      rhyme_list = [];
      rhyme_close = React.DOM.li({
        className: "pos"
      }, "Close");
      rhyme_list.push(rhyme_close);
      rhyme_list.push(React.DOM.li({
        className: "entry"
      }, data.rhymes.close.join(", ")));
      rhyme_eh = React.DOM.li({
        className: "pos"
      }, "Eh..");
      rhyme_list.push(rhyme_eh);
      rhyme_list.push(React.DOM.li({
        className: "entry"
      }, data.rhymes.eh.join(", ")));
      rhyme_section = React.DOM.div({
        id: "reference_rhyme_section",
        className: "reference_section " + view.rhyme
      }, React.DOM.h4({
        className: "section_head",
        onClick: function() {
          return viewSection(3);
        }
      }, "Rhymes", tip.rhyme), rhyme_list);
      list = [];
      list.push(dictionary_section);
      list.push(synonym_section);
      list.push(rhyme_section);
      body = list;
    } else {
      body = Button.get("do_search", {
        onclick: function() {
          return ReferenceAction.lookup(search_query.value);
        }
      });
    }
    return React.DOM.div({
      id: "search",
      className: "invisible user_background",
      style: {
        background: Lyric.State.User.background
      }
    }, React.DOM.div({
      className: "toolbar"
    }, Button.get("back"), React.DOM.form({
      onSubmit: this.lookup
    }, React.DOM.div({
      id: "search_query_container"
    }, UI.textfield("search_query", {
      onChange: this.queryUpdate
    })))), React.DOM.div({
      id: "search_body",
      className: "body",
      onScroll: this.scrollEvent
    }, body), React.DOM.div({
      id: "scroll_top_container",
      className: (this.state.show_to_top ? "" : "invisible"),
      onClick: function() {
        return scrollToTop();
      }
    }, Button.get("search_scroll_to_top")));
  }
});

// Generated by CoffeeScript 1.8.0
UI.settings_pane = React.createClass({
  getInitialState: function() {
    return {
      level_location: [],
      layout: ""
    };
  },
  selectOption: function(hash) {
    var l_l;
    l_l = this.state.level_location;
    l_l.push(hash);
    return this.setState({
      level_location: l_l
    });
  },
  goBack: function() {
    return this.setState({
      layout: ""
    });
  },
  openLayout: function(layout) {
    this.setState({
      layout: layout
    });
    return console.log("lay ", layout);
  },
  render: function() {
    var body, body_list, current_level, id, keys, lay, li, openLayout, url, _i, _len;
    if ((this.state.layout != null) && this.state.layout.length > 0) {
      body = new Layout[this.state.layout]({});
    } else {
      current_level = this.props.levels;
      openLayout = this.openLayout;
      keys = Object.keys(current_level);
      body_list = [];
      for (_i = 0, _len = keys.length; _i < _len; _i++) {
        id = keys[_i];
        li = {};
        switch (current_level[id]["type"]) {
          case "link":
            li.label = current_level[id]["label"];
            url = current_level[id]["url"];
            li.onClick = function() {
              return window.location = url;
            };
            break;
          case "layout":
            li.label = current_level[id]["label"];
            lay = current_level[id]["layout"];
            li.onClick = function() {
              return openLayout(lay);
            };
            break;
          case "inline":
            li.layout = current_level[id]["layout"];
            break;
          case "action":
            li.label = current_level[id]["label"];
            li.onClick = function() {
              return Lyric.action(current_level[id]["action"]);
            };
            break;
          case "func":
            li.label = current_level[id]["label"];
            li.onClick = current_level[id]["func"];
        }
        li.key = id;
        if (li.layout != null) {
          body_list.push(new Layout[current_level[id]["layout"]]({}));
        } else {
          body_list.push(UI.settings_pane_item(li));
        }
      }
      body = React.DOM.ul({
        className: "list"
      }, body_list);
    }
    React.DOM.span({}, body);
    return React.DOM.div({
      className: "settings_pane"
    }, body, UI.settings_pane_back({
      visible: this.state.layout.length > 0,
      onclick: this.goBack
    }));
  }
});

UI.settings_pane_back = React.createClass({
  render: function() {
    if (this.props.visible) {
      return React.DOM.div({
        className: "center_text"
      }, React.DOM.button({
        id: "settings_pane_back",
        onClick: this.props.onclick,
        className: "button"
      }, "Done"));
    } else {
      return React.DOM.span({});
    }
  }
});

UI.settings_pane_item = React.createClass({
  render: function() {
    var label, onclick;
    onclick = this.props.onClick;
    label = this.props.label;
    return React.DOM.li({
      id: "settings_pane_item_" + this.props.key,
      onClick: function() {
        return onclick(label);
      }
    }, label);
  }
});

Layout.lyric_ugi_branding = React.createClass({
  render: function() {
    return React.DOM.li({
      id: "ugi_logo_container"
    }, React.DOM.div({
      id: "uriel_group_logo_love"
    }, "Made with ", React.DOM.i({
      className: "fa fa-heart"
    }), " by"), React.DOM.div({
      id: "uriel_group_logo"
    }));
  }
});

// Generated by CoffeeScript 1.8.0
var Layout;

Layout = {};

Layout.user_access = React.createClass({
  getInitialState: function() {
    return {
      password_visible: "invisible"
    };
  },
  render: function() {
    return React.DOM.div({
      id: "user_access"
    }, React.DOM.div({
      id: "video_bg"
    }, React.DOM.div({
      id: "content"
    }, React.DOM.div({
      id: "personal_background_color",
      "class": "user_background"
    }), React.DOM.div({
      id: "action_container"
    }, React.DOM.div({
      id: "user_access_email_container",
      className: "center_text white"
    }, React.DOM.div({
      className: "container"
    }, React.DOM.div({
      className: "logo"
    }, React.DOM.div({
      className: "tag"
    }, "Enhance Your Writing Experience")), React.DOM.form({
      onSubmit: function(e) {
        e.preventDefault();
        return UserAction.checkEmail();
      }
    }, UI.textfield("user_access_email"), React.DOM.button({
      id: "check_email_button",
      className: "button white"
    }, "Continue")))), React.DOM.div({
      id: "user_access_password_container",
      className: this.state.password_visible
    }, React.DOM.div({
      className: "header"
    }, Button.get("back")), React.DOM.div({
      className: "content"
    }, React.DOM.div({
      className: "logo"
    })), React.DOM.div({
      className: "container white"
    }, React.DOM.h4({}, "Login"), React.DOM.p({}, "Enter your password below and continue where you left off"), React.DOM.form({
      onSubmit: function(e) {
        e.preventDefault();
        return UserAction.login();
      }
    }, UI.textfield("user_access_password"), Button.get("user_access_password_submit", {
      className: "button right white"
    })))), React.DOM.div({
      id: "user_access_create_passwords_container",
      className: "invisible"
    }, React.DOM.div({
      className: "header"
    }, Button.get("back_click", {
      onclick: (function() {
        Lyric.State.setCurrentPage("user_access_create_password");
        Lyric.State.lastPage = "user_access_email";
        return Lyric.back();
      })
    })), React.DOM.div({
      className: "content"
    }, React.DOM.div({
      className: "logo"
    })), React.DOM.div({
      className: "container white "
    }, React.DOM.h4({}, "Create an Account"), React.DOM.p({}, "Pick a password and make sure they match!"), React.DOM.form({
      onSubmit: function(e) {
        e.preventDefault();
        return UserAction.checkCreatePassword(user_access_create_password_1.value, user_access_create_password_2.value);
      }
    }, UI.textfield("user_access_create_password_1"), UI.textfield("user_access_create_password_2"), Button.get("user_access_create_password_submit", {
      className: "button right white"
    })))), Layout.user_access_create_introduction_container({
      setup: true
    })))));
  }
});

Layout.user_access_create_introduction_container = React.createClass({
  getInitialState: function() {
    return {
      visible: "invisible",
      stagename: Lyric.State.User.stagename
    };
  },
  stagenameOnChange: function() {
    return UserAction.updateStagename(user_access_create_stagename.value);
  },
  typeOnChange: function() {
    return UserAction.updateType(user_art_type.selectedIndex);
  },
  render: function() {
    var colors, colors_divs, elements;
    colors = Lyric.config.colors;
    colors_divs = colors.map(function(color) {
      return React.DOM.li({
        className: "color_circle",
        key: color,
        style: {
          background: color
        },
        onTouchStart: function(e) {},
        onClick: function(e) {
          UserAction.updateBackground(color);
          if (typeof personal_background_color !== "undefined" && personal_background_color !== null) {
            return personal_background_color.remove();
          }
        }
      }, "");
    });
    if ((Lyric.State.Account != null) && (Lyric.State.Account.custom_color != null) && Lyric.State.Account.custom_color) {
      colors_divs.push(React.DOM.li({
        id: "custom_color",
        className: "color_circle center_text",
        onClick: function() {
          return UserAction.updateBackground("", true);
        }
      }, React.DOM.i({
        className: "fa fa-tachometer"
      }), React.DOM.span({}, "Custom")));
    }
    elements = [
      React.DOM.h5({}, "Personalize"), React.DOM.div({
        className: "pushDown"
      }, "What name do you go by?", UI.textfield("user_access_create_stagename", {
        onChange: this.stagenameOnChange,
        defaultValue: Lyric.State.User.stagename
      })), React.DOM.div({
        className: "pushDown"
      }, "What do you create most?", UI.select("user_art_type", {
        onChange: this.typeOnChange,
        selectedIndex: Lyric.State.User.typeIndex
      }), "."), React.DOM.div({
        className: "pushDown"
      }, "Lyric Color", React.DOM.ul({}, colors_divs))
    ];
    if (this.props.setup) {
      elements.unshift(React.DOM.div({
        className: "header"
      }, Button.get("back"), ""));
      elements.push(React.DOM.form({
        onSubmit: function(e) {
          e.preventDefault();
          return UserAction.createUser();
        }
      }, Button.get("user_access_create_start", {
        className: "white button right"
      })));
    }
    return React.DOM.div({
      id: "user_access_create_introduction_container",
      className: this.state.visible + " lead white user_background"
    }, React.DOM.div({
      className: "container"
    }, elements));
  }
});

Layout.user_access_create_process_container = React.createClass({
  getInitialState: function() {
    return {
      visible: "invisible"
    };
  },
  render: function() {
    return React.DOM.div({
      id: "user_access_create_process_container",
      className: "center_text white"
    }, React.DOM.div({
      id: "user_access_process_logo"
    }), React.DOM.p({
      id: "user_access_process_label",
      className: "lead"
    }, "Creating Account"), React.DOM.div({}, React.DOM.i({
      id: "user_access_process_spinner",
      className: "fa fa-gear fa-spin"
    }, ""), React.DOM.form({
      id: "user_access_process_action",
      className: "invisible",
      onSubmit: function(e) {
        var command;
        e.preventDefault();
        command = {
          service: "user",
          action: "create_user"
        };
        return Lyric.action(command);
      }
    }, Button.get("try_again_text"))), React.DOM.div({
      className: "uriel_group_logo_container"
    }, React.DOM.div({
      className: "uriel_group_logo"
    }, "")));
  }
});
