// Generated by CoffeeScript 1.8.0
var Transition;

Transition = {
  fadeOutSlideLeft: function(args) {
    return Velocity(args.element, {
      opacity: [0, 1],
      translateX: ["-20px", 0]
    }, {
      duration: 300,
      complete: args.complete
    });
  },
  fadeOutSlideRight: function(args) {
    return Velocity(args.element, {
      opacity: 0,
      translateX: ["20px", 0]
    }, {
      duration: 300,
      easing: "easeInQuart",
      complete: args.complete
    });
  },
  fadeIn: function(args) {
    return Velocity(args.element, {
      opacity: [1, 0]
    }, {
      duration: 300,
      complete: args.complete
    });
  },
  fadeOut: function(args) {
    args.element.style.opacity = 0;
    return Velocity(args.element, {
      opacity: [0, 1]
    }, {
      duration: 300,
      complete: args.complete
    });
  },
  fadeInSlideRight: function(args) {
    args.element.style.opacity = 0;
    return Velocity(args.element, {
      opacity: 1,
      translateX: ["0px", "20px"]
    }, {
      duration: 300,
      easing: args.easing ? args.easing : "easeOutQuart",
      complete: args.complete
    });
  },

  /*
      User access email and user access password
   */
  user_access_email__user_access_password: function() {
    user_access_password_container.classList.remove("invisible");
    this.fadeOutSlideLeft({
      element: user_access_email_container
    });
    return this.fadeIn({
      element: user_access_password_container,
      complete: (function() {
        return user_access_password.focus();
      })
    });
  },
  user_access_password__user_access_email: function() {
    user_access_email_container.classList.remove("invisible");
    Velocity(user_access_password_container, "reverse");
    Velocity(user_access_email_container, "reverse", {
      complete: function() {
        return user_access_password_container.classList.add("invisible");
      }
    });
  },
  user_access_email__user_access_create_password: function() {
    user_access_create_passwords_container.classList.remove("invisible");
    this.fadeOutSlideLeft({
      element: user_access_email_container,
      complete: function() {
        return user_access_email_container.classList.add("invsible");
      }
    });
    return this.fadeIn({
      element: user_access_create_passwords_container
    });
  },
  user_access_create_password__user_access_email: function() {
    user_access_email_container.classList.remove("invisible");
    Velocity(user_access_create_passwords_container, "reverse");
    Velocity(user_access_email_container, "reverse", {
      complete: function() {
        return user_access_create_passwords_container.classList.add("invisible");
      }
    });
  },
  user_access_create_password__user_access_create_introduction: function() {
    user_access_create_introduction_container.classList.remove("invisible");
    this.fadeOutSlideLeft({
      element: user_access_create_passwords_container,
      complete: (function() {
        return user_access_create_passwords_container.classList.add("invsible");
      })
    });
    return this.fadeIn({
      element: user_access_create_introduction_container,
      complete: (function() {
        return user_access_create_stagename.focus();
      })
    });
  },
  user_access_create_introduction__user_access_create_password: function() {
    user_access_create_passwords_container.classList.remove("invisible");
    Velocity(user_access_create_passwords_container, "reverse");
    return Velocity(user_access_create_introduction_container, "reverse", {
      complete: function() {
        return user_access_create_introduction_container.classList.add("invisible");
      }
    });
  },

  /*
      Project List
   */
  project_list__project_add: function() {
    project_list_overlay.style["display"] = "block";
    this.fadeIn({
      element: project_list_overlay
    });
    return Velocity(project_list_add_container, {
      translateY: [135, 0]
    }, {
      duration: 300,
      complete: function() {
        return project_list_add_title.focus();
      }
    });
  },
  project_add__project_list: function() {
    this.fadeOut({
      element: project_list_overlay,
      complete: function() {
        return project_list_overlay.style["display"] = "none";
      }
    });
    return Velocity(project_list_add_container, {
      translateY: [0, 135]
    }, {
      duration: 300,
      complete: function() {}
    });
  },
  project_list__editor: function() {
    lyric_workspace.style["display"] = "block";
    project_menu_footer_toolbar.style["display"] = "none";
    return Velocity(lyric_workspace, {
      translateY: [0, Lyric.State.project_list_select_offset],
      translateX: [0, 0]
    }, {
      duration: 300,
      easing: "easeInQuad",
      complete: function() {
        editor_activator.classList.add("invisible");
        return project_menu_footer_toolbar.style["display"] = "block";
      }
    });

    /*Animate individual list items
    for element,index in Lyric.State.current_project.verses_index
        console.log element
        if window["verse_"+element]?
            window["verse_"+element].style.transform="translateY(100px)"
        delay = Lyric.State.current_project.verses_index-index
        Velocity(window["verse_"+element],
            {
                translateY:[0,100]
                opacity:[1,0]
            },
            {
                duration: 200
                delay:((2+index)*50)
            }
        )
     */
  },

  /*
      Project Menu
   */
  project_menu__editor: function() {
    return Velocity(lyric_workspace_container, {
      translateX: "-93%"
    }, {
      duration: 300,
      easing: "easeIn",
      complete: function() {
        var ux;
        editor_activator.classList.add("invisible");
        ux = {
          service: "ux",
          action: "project_menu_body_tab_set",
          pos: 0
        };
        return Lyric.action(ux);
      }
    });
  },

  /*
      Editor
   */
  editor__project_menu: function() {
    Velocity(lyric_workspace_container, {
      translateX: ["0", "-93%"]
    }, {
      duration: 300,
      easing: "easeOutQuad",
      complete: function() {
        editor_activator.classList.remove("invisible");
        return Lyric.clearCurrentVerseHash();
      }
    });
    return VerseAction.toProjectMenu();
  },
  editor__search: function() {
    search.classList.remove("invisible");
    return this.fadeInSlideRight({
      element: search
    });
  },
  search__editor: function() {
    return this.fadeOutSlideRight({
      element: search,
      complete: function() {
        return search.classList.add("invisible");
      }
    });
  },
  project_menu__project_list: function() {
    return this.fadeOutSlideRight({
      element: lyric_workspace,
      complete: function() {
        lyric_workspace.style.removeProperty('-webkit-transform');
        lyric_workspace_container.style.removeProperty("-webkit-transform");
        lyric_workspace_container.style.removeProperty("transform");
        lyric_workspace.style["opacity"] = "1";
        lyric_workspace.style["display"] = "none";
        return Lyric.clearCurrentProjectHash();
      }
    });
  },
  project_list__extra: function() {
    return Velocity(app, {
      translateX: "100%"
    }, {
      duration: 300
    });
  },
  extra__project_list: function() {
    return Velocity(app, {
      translateX: "0%"
    }, {
      duration: 300
    });
  },
  project_menu__extra: function() {
    return this.project_list__extra();
  },
  extra__project_menu: function() {
    return this.extra__project_list();
  },
  editor__extra: function() {
    return this.project_list__extra();
  },
  extra__editor: function() {
    return this.extra__project_list();
  }
};
