// Generated by CoffeeScript 1.8.0
var DB;

DB = {
  db: null,
  init: function() {
    var request;
    this.sql = window.indexedDB == null;
    if (!this.sql) {
      request = indexedDB.open("Lyric", 2);
      request.onsuccess = function(event) {
        DB.db = event.target.result;
        Data.setup();
        return DB.db.onerror = function(event) {
          return console.log("Database error: " + event.target.errorCode);
        };
      };
      request.onupgradeneeded = function(event) {
        var db, projectStore;
        console.log("upgrade");
        db = event.target.result;
        projectStore = db.createObjectStore("projects", {
          keyPath: "hash"
        });
        projectStore.createIndex("title", "title", {
          unique: false
        });
        return console.log("done upgrade");
      };
    } else {
      this.db = openDatabase('lyric', '1', 'Projects', 10 * 1024 * 1024);
      this.exec("CREATE TABLE IF NOT EXISTS projects (hash unique,project)");
      return Data.setup();
    }
  },
  addProject: function(project) {
    var projectStore, project_json, request, transaction;
    if (!this.sql) {
      transaction = this.db.transaction(["projects"], "readwrite");
      projectStore = transaction.objectStore("projects");
      request = projectStore.add(project);
      return request.onsuccess = function(event) {
        return console.log("Project ", project.hash, " added");
      };
    } else {
      project_json = JSON.stringify(project);
      return this.exec("insert into projects values (" + project.hash + ",'" + project_json + "')");
    }
  },
  deleteProject: function(project_hash) {
    var projectStore, request, transaction;
    if (!this.sql) {
      transaction = this.db.transaction(["projects"], "readwrite");
      projectStore = transaction.objectStore("projects");
      request = projectStore["delete"](project_hash);
      return request.onsuccess = function(event) {};
    } else {
      return this.exec("delete from projects where hash=" + project_hash);
    }
  },
  getProject: function(project_hash, callback) {
    var db, project, projectStore, request, transaction;
    if (!this.sql) {
      transaction = this.db.transaction(["projects"], "readwrite");
      projectStore = transaction.objectStore("projects");
      project = {};
      request = projectStore.get(project_hash);
      request.onsuccess = function(event) {
        project = request.result;
        return callback(project);
      };
      return true;
    } else {
      db = this.db;
      db.transaction(function(tx) {
        return tx.executeSql("select hash,project from projects where hash=" + project_hash, [], function(tx, results) {
          var row;
          if (results.rows.length > 0) {
            row = results.rows.item(0);
            project = JSON.parse(row.project);
            return callback(project);
          }
        });
      });
      return true;
    }
  },
  updateProject: function(project) {
    var db, projectStore, project_json, request, transaction;
    if (!this.sql) {
      transaction = this.db.transaction(["projects"], "readwrite");
      projectStore = transaction.objectStore("projects");
      request = projectStore.put(project);
      return true;
    } else {
      project_json = JSON.stringify(project);
      db = this.db;
      db.transaction(function(tx) {
        Data.localSet("current_project_json", project_json);
        return tx.executeSql("select hash,project from projects where hash=" + project.hash, [], function(tx, results) {
          if (results.rows.length > 0) {
            return DB.exec("update projects set project='" + project_json + "' where hash=" + project.hash + ";");
          } else {
            return DB.exec("insert into projects values (" + project.hash + ",'" + project_json + "')");
          }
        });
      });
      return true;
    }
  },
  getAll: function(callback) {
    var cursorRequest, db, keyRange, projectStore, projects, transaction;
    projects = [];
    if (!this.sql) {
      transaction = this.db.transaction(["projects"], "readwrite");
      projectStore = transaction.objectStore("projects");
      transaction.oncomplete = function() {
        return callback(projects);
      };
      keyRange = IDBKeyRange.lowerBound(0);
      cursorRequest = projectStore.openCursor(keyRange);
      cursorRequest.onsuccess = function(e) {
        var result;
        result = e.target.result;
        if (!!result === false) {
          return;
        }
        projects.push(result.value);
        return result["continue"]();
      };
    } else {
      db = this.db;
      return db.transaction(function(tx) {
        return tx.executeSql("select hash,project from projects ", [], function(tx, results) {
          var i, project, row, _i, _ref;
          if (results.rows.length > 0) {
            for (i = _i = 0, _ref = results.rows.length - 1; 0 <= _ref ? _i <= _ref : _i >= _ref; i = 0 <= _ref ? ++_i : --_i) {
              row = results.rows.item(i);
              project = JSON.parse(row.project);
              projects.push(project);
            }
          }
          return callback(projects);
        });
      });
    }
  },
  exec: function(sql) {
    var db;
    db = this.db;
    return db.transaction(function(tx) {
      return tx.executeSql(sql);
    });
  },
  deleteDB: function() {
    if (!this.sql) {
      return window.indexedDB.deleteDatabase("Lyric");
    } else {
      return DB.exec("delete from projects");
    }
  }
};
