// Generated by CoffeeScript 1.8.0
var Sync, SyncAction, SyncStore;

SyncAction = Reflux.createActions(["sync", "syncDone", "addBetaNote", "syncCheck", "syncError"]);

SyncStore = Reflux.createStore({
  listenables: SyncAction,
  Status: {},
  syncError: function() {
    var payload;
    this.Status = payload = {
      syncing: 2,
      sync_status: "Hmmmm, are you connected to the internet?"
    };
    this.trigger(payload);
    project_list_footer_sync.children[1].classList.add("error");
    return project_list_footer_sync.children[1].classList.remove("fa-spin");
  },
  sync: function(action, type) {
    var payload, projects, user;
    if (type == null) {
      type = action;
    }
    Data.localSet("last_synced", Date.now());
    project_list_footer_sync.children[1].classList.remove("error");
    project_list_footer_sync.children[1].classList.add("fa-spin");
    this.Status = payload = {
      syncing: 1,
      sync_status: "Syncing"
    };
    this.trigger(payload);
    projects = {};
    Data.project_list().map(function(i) {
      if (i != null) {
        return projects[i[0]] = i[2];
      }
    });
    user = Lyric.State.User;
    user.account = null;
    payload = {
      service: "sync",
      action: action,
      type: type,
      hash: Lyric.State.User.hash,
      user: user,
      device: navigator.userAgent,
      beta_notes: Data.localGet("beta_notes", null),
      delete_log: Data.localGet("delete_log", null),
      projects: JSON.stringify(projects)
    };
    Sync.payload = payload;
    return DB.getAll(Sync.fillHold);
  },
  syncCheck: function() {
    var current, last;
    last = parseInt(Data.localGet("last_synced"));
    current = Date.now();
    if (last + 60000 * Lyric.State.Account.sync_interval <= current) {
      return this.sync("bootcheck", "auto_sync");
    }
  },
  syncDone: function() {
    var payload, type;
    project_list_footer_sync.children[1].classList.remove("fa-spin");
    this.Status = payload = {
      project_list: Data.project_list(),
      syncing: 0,
      sync_status: "Last Synced " + (new Date().toLocaleString())
    };
    type = Sync.payload.type;
    Sync.payload = {};
    Data.localSet("beta_notes", JSON.stringify([]));
    Data.localSet("delete_log", JSON.stringify([]));
    if (type === "login") {
      app.style["-webkit-transform"] = "translateX(0%)";
    }
    return this.trigger(payload);
  },
  addBetaNote: function() {
    var beta_note, list;
    beta_note = beta_textarea.value;
    beta_textarea.value = "";
    list = JSON.parse(Data.localGet("beta_notes"));
    if (list == null) {
      list = [];
    }
    list.push(beta_note);
    Data.localSet("beta_notes", JSON.stringify(list));
    return alert("Thank You. Your note will be sent on next sync");
  }
});

Sync = {
  version: 1,
  "package": {
    user_hash: "asdfa",
    commands: []
  },
  start: function() {},
  check_all: function() {},
  check: function() {},
  checkEmail: function(email) {
    return true;
  },

  /*
      Called by components to add their request to the next package to be sent
      command:
          service
          action
          args
   */
  queue_request: function(command) {
    console.log(command);
    return this["package"].commands.push(command);
  },

  /*
      Completes an ajax request with the given command
   */
  request: function(command) {
    try {
      return qwest.before(function() {
        return this.onreadystatechange = function() {
          if (this.status === 0) {
            return Sync.error(command);
          }
        };
      }).post(Lyric.config.api_url, command, {
        retries: 3,
        responseType:'json'
      }).then(function() {
        return Sync.response(this.response);
      })["catch"](function() {
        this.response_error = true;
        return Sync.response(this.response);
      });
    } catch (_error) {}
  },

  /*
      processes responses from server
   */
  response: function(pkg) {
    var payload;
    if (typeof pkg === "string") {
      pkg = JSON.parse(pkg);
    }
    payload = pkg.data;
    payload.response = true;
    if (payload.ctrl != null) {
      Lyric.ctrl(payload);
      return;
    }
    if (payload.service === "sync") {
      Sync[payload.action](payload);
    } else {
      Lyric.action(payload);
    }
    return Lyric.State.indicator = payload.indicator;
  },
  error: function(payload) {
    payload.error = true;
    if (payload.service === "sync") {
      return SyncAction.syncError();
    } else {
      return Lyric.action(payload);
    }
  },
  payload: {},
  projects_hold: {},
  updateUserInfo: function(payload) {
    var user;
    if (payload.userinfo != null) {
      user = payload.userinfo;
      UserAction.updateType(user.art_type);
      UserAction.updateStagename(user.stagename);
      UserAction.updateBackground(user.color);
      Lyric.State.User.hash = user.hash;
      Data.localSet("user_hash", user.hash);
      Lyric.State.Account = user.account;
      Data.localSet("user_account", JSON.stringify(user.account));
      return payload.hash = user.hash;
    }
  },
  apprentist: function(payload) {
    this.updateUserInfo(payload);
    return SyncAction.syncDone();
  },
  fillHold: function(projects) {
    var payload;
    Sync.projects_hold = {};
    projects.map(function(i) {
      return Sync.projects_hold[i.hash] = i;
    });
    payload = Sync.payload;
    Sync.request(payload);
    return Sync.payload = {};
  },
  syncing: function(payload) {
    var send_project, send_project_hash;
    this.updateUserInfo(payload);
    this.updateProject(payload.trans_project_hash, payload.trans_project);
    if (payload.need != null) {
      send_project_hash = payload.need.pop();
      if (send_project_hash != null) {
        send_project = Sync.projects_hold[parseInt(send_project_hash)];
        payload.trans_project_hash = send_project_hash;
        payload.trans_project = send_project;
      }
    }
    if (((payload.need != null) && payload.need.length > 0) || ((payload.give != null) && payload.give.length > 0) || (payload.trans_project != null)) {
      return Sync.request(payload);
    } else {
      Sync.payload = payload;
      return DB.getAll(this.buildProjectList);
    }
  },
  sendProject: function(payload) {},
  buildProjectList: function(projects) {
    var not_inserted, project_list;
    project_list = Data.localGet("project_list");
    not_inserted = [];
    project_list = projects.map(function(project) {
      return [project.hash, project.title, project.modified];
    });
    Data.localSet("project_list", JSON.stringify(project_list));
    return SyncAction.syncDone();
  },
  updateProject: function(hash, project) {
    if (hash == null) {
      return;
    }
    project.hash = parseInt(project.hash);
    project.modified = parseInt(project.modified);
    return DB.updateProject(project);
  }
};
