// Generated by CoffeeScript 1.8.0
var HUBComponent, IntroductionActions, IntroductionController, backgrounds, headers, videos;

IntroductionActions = Reflux.createActions(["swipeLeft", "swipeRight", "skip", "beginning"]);

IntroductionController = Reflux.createStore({
  page: 0,
  listenables: IntroductionActions,
  swipeLeft: function() {
    if (this.page !== 0) {
      this.page--;
    }
    return this.trigger({
      page: this.page
    });
  },
  swipeRight: function() {
    if (this.page !== 4) {
      this.page++;
    }
    return this.trigger({
      page: this.page
    });
  },
  skip: function() {},
  beginning: function() {}
});

headers = ["Organize", "Lookup", "SafeSync", "Share", "Ready?"];

backgrounds = ["red", "blue", "green", "purple", "black"];

videos = ["0", "1", "2", "3"];

HUBComponent = React.createClass({
  mixins: [Reflux.listenTo(IntroductionController, "update")],
  getInitialState: function() {
    return {
      page: 0,
      sections: null,
      intro_vids: null
    };
  },
  componentDidMount: function() {
    var control, intro_vids, sections;
    sections = headers.map(function(section_name, i) {
      return React.DOM.h1({
        id: "header_" + i
      }, section_name);
    });
    intro_vids = videos.map(function(video_url, i) {
      return React.DOM.video({
        id: "video_" + i,
        src: video_url
      });
    });
    intro_vids.push(React.DOM.div({
      id: "video_" + videos.length
    }));
    control = headers.map(function(arg, i) {
      return React.DOM.li({
        id: "introduction_page_indicator_" + i
      });
    });
    control.push(React.DOM.div({}, "Skip?"));
    this.setState({
      sections: sections,
      intro_vids: intro_vids,
      control: control
    });
    return this.setNewPage({
      page: 0
    });
  },
  setNewPage: function(payload) {
    window["header_" + payload.page].classList.add("active");
    window["video_" + payload.page].classList.add("active");
    window["introduction_page_indicator_" + payload.page].classList.add("active");
    introduction_headers.style.background = backgrounds[payload.page];
    introduction_control.style.background = backgrounds[payload.page];
    console.log(backgrounds[payload.page]);
    return this.setState(payload);
  },
  update: function(payload) {
    var setNewPage;
    if (this.state.page === payload.page) {
      return;
    }
    window["header_" + this.state.page].classList.remove("active");
    window["video_" + this.state.page].classList.remove("active");
    window["introduction_page_indicator_" + this.state.page].classList.remove("active");
    setNewPage = this.setNewPage;
    return setTimeout((function() {
      return setNewPage(payload);
    }), 250);
  },
  onTouchStart: function() {},
  onTouchMove: function() {},
  onTouchEnd: function() {},
  render: function() {
    var page;
    page = this.state.page;
    return React.DOM.div({
      id: "introduction",
      onTouchStart: this.onTouchStart,
      onTouchMove: this.onTouchMove,
      onTouchEnd: this.onTouchEnd
    }, React.DOM.div({
      id: "introduction_videos"
    }, this.state.intro_vids), React.DOM.div({
      id: "introduction_headers"
    }, this.state.sections, React.DOM.div({
      className: "clear"
    })), React.DOM.div({
      id: "introduction_control"
    }, this.state.control));
  }
});

//React.renderComponent(new introduction({}), document.getElementById("viewport"));
