// Generated by CoffeeScript 1.8.0
Layout.editor = React.createClass({
  mixins: [Reflux.listenTo(VerseStore, "updateEditor")],
  getInitialState: function() {
    return {
      title: "",
      content: "",
      placeholder: "",
      touch_origin: [-1, -1]
    };
  },
  updateEditor: function(payload) {
    switch (payload.label) {
      case "selectVerse":
        return this.setState({
          title: unescape(payload.verse.title),
          content: unescape(payload.verse.content),
          placeholder: payload.placeholder
        });
    }
  },
  handleTextAreaChange: function(event) {
    var content;
    content = event.target.value;
    this.setState({
      content: content
    });
    return VerseAction.update(content);
  },
  handleTitleChange: function(event) {
    var title;
    title = event.target.value;
    if (title.length > 15) {
      title = title.substr(0, 15);
    }
    this.setState({
      title: title
    });
    return VerseAction.updateTitle(title);
  },
  onTouchStart: function(e) {
    var touch;
    touch = e.touches[0];
    return this.state.touch_origin = [e.touches[0].clientX, e.touches[0].clientY];
  },
  onTouchMove: function(e) {
    var touch_offset, x;
    touch_offset = [e.touches[0].clientX - this.state.touch_origin[0], this.state.touch_origin[1] - e.touches[0].clientY];
    Lyric.osTouchMove(e, touch_offset);
    x = touch_offset[0];
    switch (Lyric.State.getCurrentPage()) {
      case "project_menu":
        if (x < -50) {
          this.state.touch_origin = [e.touches[0].clientX, e.touches[0].clientY];
          editor_area.focus();
          return Lyric.goto("editor");
        }
        break;
      case "editor":
        if (x > 100) {
          this.state.touch_origin = [e.touches[0].clientX, e.touches[0].clientY];
          return Lyric.goto("project_menu");
        }
    }
  },
  onTouchEnd: function(e) {},
  onFocus: function() {
    if (!Lyric.State.isAndroid) {
      return editor.style.marginTop = "15px";
    }
  },
  onBlur: function() {
    if (!Lyric.State.isAndroid) {
      return editor.style.marginTop = "0px";
    }
  },
  render: function() {
    return React.DOM.div({
      id: "editor",
      onTouchMove: this.onTouchMove,
      onTouchEnd: this.onTouchEnd,
      onTouchStart: this.onTouchStart
    }, React.DOM.div({
      id: "editor_header",
      className: "toolbar"
    }, Button.get("editor_header_menu"), React.DOM.div({}, UI.textfield("editor_header_verse_title", {
      value: this.state.title,
      onChange: this.handleTitleChange
    })), Button.get("editor_header_search")), React.DOM.textarea({
      id: "editor_area",
      placeholder: this.state.placeholder,
      value: this.state.content,
      onChange: this.handleTextAreaChange,
      onFocus: this.onFocus,
      onBlur: this.onBlur
    }), Layout.editor_activator);
  }
});

Layout.editor_activator = React.DOM.div({
  id: "editor_activator",
  onClick: function() {
    if (Lyric.State.getCurrentPage() === "project_menu") {
      Lyric.goto("editor");
      editor_area.focus();
    }
  }
});
