// Generated by CoffeeScript 1.8.0
Layout.project_list = React.createClass({
  mixins: [Reflux.listenTo(ProjectStore, "create"), Reflux.listenTo(SyncStore, "update")],
  getInitialState: function() {
    return {
      scroll_header_enabled: false,
      last_scroll_y: 0,
      scrolling_up: false,
      projects: Data.project_list(),
      projects_showing: []
    };
  },
  backToTop: function() {
    return project_list_container.scrollTop = 0;
  },
  update: function(payload) {
    if (payload.project_list != null) {
      return this.setState({
        projects: payload.project_list
      });
    }
  },
  scrollEvent: function(e) {
    var toolbar;
    toolbar = project_list_search;
    if (!this.state.scroll_header_enabled && e.target.scrollTop >= toolbar.offsetTop + toolbar.clientHeight) {
      this.state.scroll_header_enabled = true;
    } else if (this.state.scroll_header_enabled && e.target.scrollTop < toolbar.offsetTop) {
      this.state.scroll_header_enabled = false;
      this.scroll_header(false);
    }
    if (this.state.scroll_header_enabled) {
      if (!this.state.scrolling_up && this.state.last_scroll_y > e.target.scrollTop) {
        this.state.scrolling_up = true;
        this.scroll_header(true);
      } else if (this.state.scrolling_up && this.state.last_scroll_y < e.target.scrollTop) {
        this.state.scrolling_up = false;
        this.scroll_header(false);
      }
    }
    if (Math.abs(this.state.last_scroll_y - project_list_container.scrollTop) !== 0) {
      Lyric.killHoldMenu();
    }
    return this.state.last_scroll_y = e.target.scrollTop;
  },
  scroll_header: function(show) {
    var f, h;
    h = project_list_scroll_header.classList;
    f = project_list_footer.classList;
    if (show) {
      h.remove("hide");
      return h.add("show");
    } else {
      h.remove("show");
      return h.add("hide");
    }
  },
  create_project: function() {
    var date, title;
    title = project_list_add_title.value;
    project_list_add_title.value = "";
    if (title.length === 0) {
      date = new Date();
      date = date.toDateString();
      project_list_add_title.value = date;
    } else {
      ProjectAction.create(title);
    }
  },
  create: function(payload) {
    if (payload.label === "project_list") {
      return this.setState({
        projects: payload.data
      });
    }
  },
  filter_list: function(e) {
    var p_l, query;
    query = project_list_search.value.toLowerCase();
    p_l = [];
    this.state.projects.map(function(entry) {
      if (entry[1].toLowerCase().indexOf(query) !== -1) {
        return p_l.push(entry);
      }
    });
    return this.setState({
      projects_showing: p_l
    });
  },
  render: function() {
    var proj_list, projects;
    projects = this.state.projects_showing.length === 0 ? this.state.projects : this.state.projects_showing;
    proj_list = projects.map(function(entry, y) {
      var hash, i, title;
      hash = entry[0];
      title = entry[1];
      i = {
        title: title,
        last_mod: "",
        hash: hash,
        key: hash,
        view: true,
        "delete": true,
        id_start: "project",
        click_command: function() {
          return ProjectAction.select(i.hash, y);
        },
        delete_onclick: function() {
          return ProjectAction.remove(i.hash);
        },
        options: [
          {
            label: "Full View",
            icon: "fa-eye",
            click: function() {
              ProjectAction.transcript(hash);
              return UIActions.hideHoldMenu();
            }
          }
        ]
      };
      return UI.list_item(i);
    });
    if (proj_list.length === 0) {
      proj_list = React.DOM.div({
        id: "empty_project"
      }, "touch the ", React.DOM.i({
        className: "fa fa-plus"
      }), " to get started");
    }
    return React.DOM.div({
      id: "project_list_main_container"
    }, React.DOM.div({
      id: "project_list_add_container",
      className: "user_background white center_text",
      style: {
        background: Lyric.State.User.background
      }
    }, UI.textfield("project_list_add_title", {
      className: "white"
    }), Button.get("new_project_create", {
      onclick: this.create_project
    })), React.DOM.div({
      id: "project_list_container",
      className: "user_background",
      onScroll: this.scrollEvent,
      onTouchStart: this.scrollEvent
    }, Layout.project_list.header({}), Layout.project_list.greeting({}), React.DOM.div({
      id: "project_list_search_container"
    }, UI.textfield("project_list_search", {
      onChange: this.filter_list
    })), React.DOM.ul({
      id: "project_list_list",
      className: "list"
    }, proj_list)), React.DOM.div({
      id: "project_list_scroll_header",
      className: "hide"
    }, React.DOM.div({
      className: "logo"
    }), React.DOM.div({
      id: ""
    }, Button.get("project_list_backToTop", {
      onclick: this.backToTop
    }))), React.DOM.div({
      id: "project_list_footer",
      className: "hide user_background"
    }, UI.toolbar("project_list_footer_toolbar")), Layout.project_list_overlay({}));
  }
});

Layout.project_list_overlay = React.createClass({
  render: function() {
    return React.DOM.div({
      id: "project_list_overlay",
      className: "overlay lead center_text white",
      onClick: function() {
        var command;
        command = {
          service: "lyric",
          action: "gotoCommand",
          to: "project_list"
        };
        return Lyric.action(command);
      }
    }, "Touch anywhere here to cancel");
  }
});

Layout.project_list.greeting = React.createClass({
  mixins: [Reflux.listenTo(UserStore, "update")],
  getInitialState: function() {
    return {
      stagename: "",
      type: "Music"
    };
  },
  update: function(payload) {
    switch (payload.label) {
      case "stagename":
        return this.setState({
          stagename: payload.name
        });
      case "type":
        return this.setState({
          type: payload.type
        });
    }
  },
  render: function() {
    return React.DOM.div({
      id: "project_list_greeting",
      className: "white"
    }, React.DOM.div({
      id: "greeting_stagename",
      className: "lead"
    }, this.state.stagename), React.DOM.h3({
      className: ""
    }, "hey,"), React.DOM.div({
      id: "greeting_prompt",
      className: "lead"
    }, "let's write some", React.DOM.span({
      id: "greeting_prompt_type"
    }, this.state.type, "!")), React.DOM.span({
      id: "stagename_scale"
    }));
  }
});

Layout.project_list.header = React.createClass({
  render: function() {
    var show_indicator;
    show_indicator = Lyric.State.indicator ? "" : " invisible";
    return React.DOM.div({
      id: "project_list_header",
      className: "toolbar white"
    }, React.DOM.div({
      id: "project_list_branding",
      onClick: function() {
        var command;
        command = {
          service: "ux",
          action: "open_extra",
          to: "lyric_hub"
        };
        return Lyric.action(command);
      }
    }, React.DOM.div({
      className: "logo"
    }), React.DOM.i({
      className: "fa fa-exclamation-circle" + show_indicator
    })), Button.get("new_project"));
  }
});

Layout.sync_center = React.createClass({
  mixins: [Reflux.listenTo(SyncStore, "update")],
  getInitialState: function() {
    return {
      hero_spinning: false,
      show_error: false,
      sync_status: "Nothing to Sync"
    };
  },
  update: function(payload) {
    var hero_spinning, show_error;
    console.log(payload);
    if (payload.syncing != null) {
      hero_spinning = payload.syncing === 1;
      show_error = payload.syncing === 2;
    }
    return this.setState({
      hero_spinning: hero_spinning,
      show_error: show_error,
      sync_status: payload.sync_status
    });
  },
  componentDidMount: function() {
    return this.update(SyncStore.Status);
  },
  render: function() {
    var hero_spin, icon, upgrade;
    upgrade = [];
    if (this.state.show_error) {
      icon = React.DOM.span({
        className: "fa-stack "
      }, React.DOM.i({
        className: "fa fa-refresh fa-stack-1x"
      }), React.DOM.i({
        className: "fa fa-ban fa-stack-1x text-danger"
      }));
    } else {
      hero_spin = this.state.hero_spinning ? "fa-spin" : "";
      icon = React.DOM.i({
        className: "fa fa-refresh " + hero_spin
      });
    }
    return React.DOM.div({
      id: "sync_center"
    }, React.DOM.div({
      className: "header"
    }, Button.get("back_from_extra"), React.DOM.span({
      className: "lead white"
    }, "Sync Center")), React.DOM.div({
      className: "body"
    }, React.DOM.div({
      id: "sync_hero"
    }, icon), React.DOM.div({
      id: "sync_status",
      className: "center_text"
    }, this.state.sync_status), Button.get("sync_now", {
      onclick: (function() {
        return SyncAction.sync("bootcheck", "manual_sync");
      })
    })));
  }
});
