// Generated by CoffeeScript 1.8.0
Layout.project_menu = React.createClass({
  mixins: [Reflux.listenTo(ProjectStore, "update")],
  getInitialState: function() {
    return {
      project_title: this.props.project_title
    };
  },
  update: function(payload) {
    if (payload.project != null) {
      this.setState({
        project_title: payload.project.title
      });
    }
    if (payload.updated_title != null) {
      this.setState({
        project_title: payload.updated_title
      });
    }
    return console.log("update project menu");
  },
  updateTitle: function() {
    return ProjectAction.updateTitle(project_title_input.value);
  },
  setTitle: function() {
    return ProjectAction.saveUpdatedTitle(project_title_input.value);
  },
  render: function() {
    return React.DOM.div({
      id: "project_menu_container"
    }, React.DOM.div({
      id: "project_menu_header",
      className: "toolbar white"
    }, Button.get("back_to_project_list"), this.state.project_title), UI.toolbar("project_menu_toolbar"), UI.toolbar("project_menu_footer_toolbar"), React.DOM.div({
      id: "project_menu_body"
    }, React.DOM.div({
      id: "project_menu_body_container"
    }, React.DOM.div({
      className: "drag_bg user_background"
    }), React.DOM.div({
      id: "drag_prompt",
      className: "lead white center_text"
    }, "Sort by dragging arrows below", Button.get("done_sorting")), Layout.project_menu_body_verses({
      verse_list: this.props.verse_list
    }), React.DOM.div({
      id: "project_menu_body_settings"
    }, React.DOM.h4({
      className: "white"
    }, "Project Title"), UI.textfield("project_title_input", {
      defaultValue: this.state.project_title,
      onChange: this.updateTitle
    })), Layout.project_menu_body_info({
      share_hash: this.props.share_hash
    }))));
  }
});

Layout.project_menu_body_info = React.createClass({
  mixins: [Reflux.listenTo(ProjectStore, "update")],
  getInitialState: function() {
    return {
      share_hash: this.props.share_hash
    };
  },
  update: function(payload) {
    var share;
    if (payload.project != null) {
      share = payload.project.share;
      if (share != null) {
        return this.setState({
          share_hash: share
        });
      } else {
        return this.setState({
          share_hash: ""
        });
      }
    }
  },
  shareLink: function() {
    return Lyric.config.share_url + this.state.share_hash;
  },
  render: function() {
    var body, fb_share, social, twitter_share;
    body = [];
    if (parseInt(Lyric.State.Account.aId) !== 2) {
      body.push(Layout.action_disabled);
    } else {
      if ((this.state.share_hash != null) && this.state.share_hash.length > 0) {
        fb_share = "https://www.facebook.com/sharer/sharer.php?u=";
        twitter_share = "https://twitter.com/intent/tweet?original_referer=http%3A%2F%2Flocalhost%2Flyric%2Fdevelop%2F3%2Flive%2Fapp%2F&text=TITLE&tw_p=tweetbutton&url=http%3A%2F%2Flyricapp.me";
        body.push(React.DOM.p({}, "Copy the link from the textfield below and share it!"));
        body.push(React.DOM.input({
          type: "text",
          onClick: function(e) {
            return e.target.select();
          },
          value: this.shareLink()
        }));
        body.push(Button.get("generate_share_hash_undo", {
          className: "roundBtn",
          onclick: function() {
            return ProjectStore.unShareHash();
          }
        }));
        social = [];
        social.push(React.DOM.a({
          className: "share_link",
          href: fb_share + this.shareLink(),
          id: "share facebook",
          target: "_blank"
        }, React.DOM.i({
          className: "fa fa-facebook-square"
        }), React.DOM.div({}, "Share On Facebook")));
        social.push(React.DOM.a({
          className: "share_link",
          href: "https://twitter.com/share",
          target: "_blank"
        }, React.DOM.i({
          className: "fa fa-twitter-square"
        }), React.DOM.div({}, "Share On Twitter")));
      } else {
        body.push(React.DOM.p({}, "Click the Generate button below to begin"));
        body.push(Button.get("generate_share_hash", {
          className: "roundBtn",
          onclick: function() {
            return ProjectStore.createShareHash();
          }
        }));
      }
    }
    return React.DOM.div({
      id: "project_menu_body_info",
      className: "center_text user_background white",
      style: {
        background: Lyric.State.User.background
      }
    }, React.DOM.div({
      id: "project_menu_body_info_container"
    }, React.DOM.h6({}, "Share Your Project"), body));
  }
});

Layout.project_menu_body_verses = React.createClass({
  mixins: [Reflux.listenTo(VerseStore, "update"), Reflux.listenTo(UIStore, "update")],
  getInitialState: function() {
    return {
      selected: "",
      verses_index: [],
      verse_list: []
    };
  },
  update: function(payload) {

    /*
    switch payload.label
        when "selectVerse"
            console.log payload
            @setState({ 
                selected: payload.verse.hash 
                verses_index: payload.verses_index
            })
        when "verses_index"
            @setState({ verses_index: payload.verses_index })
     */
    var selected, verse_list;
    if (payload.verses_index != null) {
      selected = payload.verse ? payload.verse.hash : null;
      verse_list = payload.verses_index.map(function(k) {
        var i;
        i = Lyric.State.current_project.verses[k];
        if (i == null) {
          return;
        }
        i.key = i.hash;
        i.id_start = "verse";
        i.click_command = function() {
          return VerseStore.select(i.hash);
        };
        i.options = [
          {
            label: "Sort",
            icon: "fa-list",
            click: function() {
              return UIActions.startSorting(window[i.id_start + "_" + i.hash]);
            }
          }
        ];
        if (selected != null) {
          i.className = i.hash === selected ? "selected" : "";
        }
        i.delete_onclick = function() {
          return VerseStore.remove(i.hash);
        };
        return UI.list_item(i);
      });
      return this.setState({
        verse_list: verse_list
      });
    }
  },
  project_select: function(payload) {
    switch (payload.label) {
      case "project":
        payload.label = "verse_list";
        payload.verses_index = payload.project.verses_index;
        return this.update(payload);
    }
  },
  render: function() {
    return React.DOM.div({
      id: "project_menu_body_verses"
    }, React.DOM.ul({
      className: "list",
      id: "project_menu_body_verses_ul"
    }, this.state.verse_list));
  }
});
