// Generated by CoffeeScript 1.8.0

/*
 * Project: Lyric
 * Company: Uriel Group
 * Author: Tremayne Stewart
 */
var Lyric, Ux;

Lyric = {
  killHoldMenu: function() {
    UIActions.removeCheckHold();
    UIActions.hideHoldMenu();
    return window.clearTimeout(Lyric.State.checkoutHold_timeout);
  },
  preventIfAndroid: function(e) {
    if (Lyric.State.isAndroid) {
      return e.preventDefault();
    }
  },
  osTouchMove: function(e, touch_offset) {
    if (Lyric.State.touchAction != null) {
      if (Lyric.State.touchAction === "horiz") {
        return Lyric.preventIfAndroid(e);
      }
    } else if (Math.abs(touch_offset[0]) > Math.abs(touch_offset[1])) {
      return Lyric.State.touchAction = "horiz";
    } else {
      return Lyric.State.touchAction = "vert";
    }
  },
  defaultTouchEnd: function(e) {
    return Lyric.State.touchAction = null;
  },
  generateHash: function() {
    return Date.now();
  },
  clearCurrentProjectHash: function() {
    Lyric.State.current_project_hash = "";
    Lyric.State.current_project_index = 0;
    localStorage.removeItem("lyric_current_project_hash");
    localStorage.removeItem("lyric_current_project_index");
    localStorage.removeItem("lyric_current_project_json");
    return this.clearCurrentVerseHash();
  },
  clearCurrentVerseHash: function() {
    Lyric.State.current_verse_hash = "";
    return localStorage.removeItem("lyric_current_verse_hash");
  },
  updateCurrentProjectModified: function(project_list) {
    var move;
    if (project_list == null) {
      project_list = Data.project_list();
    }
    move = project_list.splice(Lyric.State.current_project_index, 1);
    move = move.pop();
    move[2] = Lyric.State.current_project.modified;
    project_list.unshift(move);
    Lyric.State.current_project_index = 0;
    Data.localSet("project_list", JSON.stringify(project_list));
    return project_list;
  },
  config: {
    api_url: "http://www.lyricapp.me/api/index.php",
    share_url: "http://lyricapp.me/share.php?h=",
    project_settings: {
      user: {
        password: "layout_password",
        email: "layout_email"
      },
      personalize: "user_access_create_introduction_container"
    },
    lyric_settings: {
      personalize: {
        type: "layout",
        label: "Personalize",
        layout: "user_access_create_introduction_container"
      },
      nui: {
        type: "func",
        label: "Full Lyric Tour",
        func: (function() {
          return NUIActions.start();
        })
      },
      branding: {
        type: "inline",
        layout: "lyric_ugi_branding"
      },
      signout: {
        type: "action",
        label: "Sign out",
        action: {
          service: "user",
          action: "signout"
        }
      }
    },
    types: ["Music", "Poetry", "Slam", "Other"],
    colors: ["#1abc9c", "#2ecc71", "#3498db", "#3A539B", "#9b59b6", "#e74c3c", "#96281B", "#e67e22", "#f1c40f", "#F2784B", "#34495e", "#bdc3c7"],
    placeholders: {
      Music: ["Music is what feelings sound like", "Where words leave off, music begins", "Where words fail, music speaks", "Music is the strongest form of magic", "Music can change the world because it can change people", "Poetry is truth in its Sunday clothes. ~ Joseph Roux", "Poetry can be dangerous, especially beautiful poetry, because it gives the illusion of having had the experience without actually going through it. ~ Rumi", "Poetry is just the evidence of life. If your life is burning well, poetry is just the ash. ~ Leonard Cohen", "If I feel physically as if the top of my head were taken off, I know that is poetry. ~ Emily Dickinson", "Poetry is plucking at the heartstrings, and making music with them. ~ Dennis Gabor", "Poetry is the journal of a sea animal living on land, wanting to fly in the air. ~ Carl Sandburg"],
      Poetry: ["Poetry is truth in its Sunday clothes. ~ Joseph Roux", "Poetry can be dangerous, especially beautiful poetry, because it gives the illusion of having had the experience without actually going through it. ~ Rumi", "Poetry is just the evidence of life. If your life is burning well, poetry is just the ash. ~ Leonard Cohen", "If I feel physically as if the top of my head were taken off, I know that is poetry. ~ Emily Dickinson", "Poetry is plucking at the heartstrings, and making music with them. ~ Dennis Gabor", "Poetry is the journal of a sea animal living on land, wanting to fly in the air. ~ Carl Sandburg"]
    }
  },
  State: {
    History: [],
    lastPage: "",
    currentPage: "",
    getCurrentPage: function() {
      return this.currentPage;
    },
    setCurrentPage: function(add) {
      this.lastPage = this.currentPage;
      return this.currentPage = add;
    },
    current_project_hash: "",
    current_verse_hash: "",
    project_list_select_offset: 0,
    isAndroid: false,
    User: {
      stagename: "",
      background: "",
      typeIndex: 0
    }
  },
  Register: {
    Data: [],
    get: function(key) {
      return this.Data[key];
    },
    set: function(key, value) {
      var prev;
      prev = this.Data[key];
      this.Data[key] = value;
      return prev;
    },
    remove: function(key) {
      return delete this.Data[key];
    }
  },
  gotoFrom: function(from, to) {
    console.log(from, to);
    Transition[from + "__" + to]();
    return this.State.setCurrentPage(to);
  },
  goto: function(to) {
    return this.gotoFrom(this.State.getCurrentPage(), to);
  },
  gotoCommand: function(command) {
    return this.goto(command.to);
  },
  action: function(command) {
    var service;
    service = command.service.charAt(0).toUpperCase() + command.service.substring(1);
    if (command.response != null) {
      return window[service]["response"][command.action](command);
    } else if (command.error != null) {
      return window[service]["error"][command.action](command);
    } else {
      return window[service][command.action](command);
    }
  },
  ctrl: function(payload) {
    var command;
    console.log(payload);
    switch (payload.action) {
      case "signout":
        User.signout();
        break;
      case "hub":
        command = {
          service: "ux",
          action: "open_extra",
          to: "lyric_hub"
        };
        Lyric.action(command);
    }
    if (payload.alert != null) {
      return alert(payload.alert);
    }
  },
  back: function() {
    var current, to;
    current = this.State.currentPage;
    to = this.State.lastPage;
    return this.gotoFrom(current, to);
  },
  init: function() {
    React.initializeTouchEvents(true);
    document.addEventListener("touchend", Lyric.defaultTouchEnd);
    return DB.init();
  }
};

Ux = {
  selectProject: function(command) {
    var new_y;
    new_y = window["project_" + command.id].offsetTop - project_list_container.scrollTop;
    Lyric.State.project_list_select_offset = new_y;
    return Lyric.goto("editor");
  },
  project_menu_body_tab_set: function(command) {
    var btns;
    btns = [project_menu_toolbar_verses, project_menu_toolbar_settings, project_menu_toolbar_info];
    btns.forEach(function(ele) {
      return ele.classList.remove("selected");
    });
    btns[command.pos].classList.add("selected");
    return project_menu_body_container.style["-webkit-transform"] = "translateX(" + (command.pos * -100) + "%)";
  },
  open_extra: function(command) {
    ExtraPaneAction(command.to);
    return Lyric.goto("extra");
  },
  close_extra: function() {
    return Lyric.back();
  }
};
