// Generated by CoffeeScript 1.8.0
var UI;

UI = {
  Config: {
    textfield: {
      user_access_email: {
        placeholder: "Enter email address to begin",
        input_type: "email",
        input_class_name: "underline_textfield"
      },
      user_access_password: {
        placeholder: "Password",
        input_type: "password",
        input_class_name: "underline_textfield",
        button_id: "user_access_password_submit",
        command: "action",
        command_args: "user_access check_password"
      },
      user_access_create_password_1: {
        placeholder: "Create Password",
        input_type: "password",
        input_class_name: "underline_textfield"
      },
      user_access_create_password_2: {
        placeholder: "Repeat Password",
        input_type: "password",
        input_class_name: "underline_textfield"
      },
      user_access_create_stagename: {
        placeholder: "your name",
        input_type: "text",
        input_class_name: "underline_textfield"
      },
      editor_header_verse_title: {
        placeholder: "Verse"
      },
      project_title_input: {
        input_type: "text",
        input_class_name: "underline_textfield"
      },
      search_query: {
        placeholder: "Enter a word",
        input_type: "text",
        input_class_name: "underline_textfield",
        command: "action",
        command_args: "user_access check_password"
      },
      project_list_search: {
        placeholder: "Search for a project",
        input_class_name: "underline_textfield white"
      },
      project_list_add_title: {
        placeholder: "What are we calling it?",
        input_class_name: "underline_textfield"
      }
    },
    select: {
      user_art_type: {
        options: Lyric.config.types
      }
    },
    form: {
      user_access_email: {
        textfields_ids: ["user_access_email"],
        command: "action",
        command_args: "user_access check_email"
      },
      user_access_create_passwords: {
        textfields_ids: ["user_access_create_password_1", "user_access_create_password_2"],
        button_id: "user_access_create_password_submit",
        command: "action",
        command_args: "user_access create_password_submit"
      }
    },
    toolbar: {
      project_list_toolbar: {
        buttons: ["project_list_toolbar_show_projects", "project_list_toolbar_search"]
      },
      project_list_scroll_header_toolbar: {
        buttons: ["project_list_toolbar_show_projects", "project_list_toolbar_search"]
      },
      project_list_footer_toolbar: {
        buttons: ["project_list_footer_beta", "project_list_footer_sync", "project_list_footer_settings"]
      },
      project_menu_toolbar: {
        buttons: ["project_menu_toolbar_verses", "project_menu_toolbar_settings", "project_menu_toolbar_info"]
      },
      project_menu_music_control: {
        buttons: ["project_menu_music_rewind", "project_menu_music_play", "project_menu_music_settings"]
      },
      project_menu_footer_toolbar: {
        buttons: ["new_verse"]
      }
    }
  },
  build_solo_textfield: React.createClass({
    render: function() {
      return React.DOM.div({
        className: this.props.input_class_name
      }, React.DOM.div({}, React.DOM.input({
        type: this.props.input_type,
        id: this.props.id,
        placeholder: this.props.placeholder
      }, "")), Button.get(this.props.button_id));
    }
  }),
  build_textfield: React.createClass({
    render: function() {
      return React.DOM.input({
        type: this.props.input_type,
        id: this.props.id,
        className: this.props.input_class_name,
        placeholder: this.props.placeholder,
        value: this.props.value,
        onChange: this.props.onChange,
        defaultValue: this.props.defaultValue
      });
    }
  }),
  build_select: React.createClass({
    render: function() {
      var b;
      b = this.props.options.map(function(i, y) {
        return React.DOM.option({
          key: i,
          value: y
        }, i);
      });
      return React.DOM.select({
        id: this.props.id,
        onChange: this.props.onChange,
        defaultValue: this.props.selectedIndex
      }, b);
    }
  }),
  select: function(id, additional) {
    var config, k, _i, _len, _ref;
    config = this.Config.select[id];
    if (additional != null) {
      _ref = Object.keys(additional);
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        k = _ref[_i];
        config[k] = additional[k];
      }
    }
    config.id = id;
    return this.build_select(config);
  },
  textfield: function(id, additional) {
    var config, k, _i, _len, _ref;
    config = this.Config.textfield[id];
    if (additional != null) {
      _ref = Object.keys(additional);
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        k = _ref[_i];
        config[k] = additional[k];
      }
    }
    config.id = id;
    return this.build_textfield(config);
  },
  solo_textfield: function(id) {
    var config;
    config = this.Config.textfield[id];
    config.id = id;
    config.action = function(e) {
      e.preventDefault();
      if (config.command === "action") {
        return Lyric.action(config.command_args);
      } else {
        return Lyric.goto(config.command_args);
      }
    };
    return this.build_solo_textfield(config);
  },
  build_toolbar: React.createClass({
    render: function() {
      var btns, button_additional;
      button_additional = {
        style: this.props.button_style
      };
      btns = this.props.buttons.map(function(i) {
        return Button.get(i, button_additional);
      });
      return React.DOM.div({
        id: this.props.id,
        className: "toolbar"
      }, btns);
    }
  }),
  toolbar: function(id) {
    var config;
    config = this.Config.toolbar[id];
    config.id = id;
    if (config.buttons != null) {
      config.button_style = {
        width: 100 / config.buttons.length + "%",
        height: "100%"
      };
    }
    return this.build_toolbar(config);
  },
  list_item_hold_menu: React.createClass({
    mixins: [Reflux.listenTo(UIStore, "fromUI")],
    getInitialState: function() {
      return {
        options: [],
        delete_onclick: null
      };
    },
    fromUI: function(payload) {
      if (payload.options != null) {
        return this.setState({
          options: payload.options,
          delete_onclick: payload.delete_onclick
        });
      }
    },
    render: function() {
      var elements, option, _i, _len, _ref;
      elements = [];
      elements.push(React.DOM.div({
        className: "back"
      }, Button.get("list_hold_menu_back", {
        onclick: UIActions.hideHoldMenu
      })));
      _ref = this.state.options;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        option = _ref[_i];
        elements.push(React.DOM.div({
          className: "main_action"
        }, Button.get("list_hold_menu_main", {
          onclick: option.click,
          icon: option.icon
        })));
        elements.push(React.DOM.span({
          className: "label",
          onClick: option.click
        }, option.label));
      }
      elements.push(React.DOM.div({
        className: "remove right"
      }, Button.get("project_list_remove", {
        onclick: this.state.delete_onclick
      })));
      return React.DOM.div({
        id: "list_item_hold_menu"
      }, elements);
    }
  }),
  list_item: React.createClass({
    mixins: [Reflux.listenTo(UIStore, "fromUI")],
    getInitialState: function() {
      return {
        touch_origin: [-1, -1],
        current_touch: [-1, -1],
        trans_x: 0,
        activated: false,
        max_drag: 0,
        closed_others: false,
        sorting: false
      };
    },
    fromUI: function(payload) {
      if (payload.sorting != null) {
        return this.setState({
          sorting: payload.sorting
        });
      }
    },
    componentDidMount: function() {
      var elem;
      elem = window[this.props.id_start + "_" + this.props.hash];
      return this.setState({
        elem: elem
      });
    },
    checkingHold: false,
    checkingHold_timeout: null,
    checkHold: function() {
      if (this.checkingHold) {
        this.checkingHold = false;
        return UIActions.showHoldMenu(this.state.elem, this.props);
      }
    },
    sortTouchStart: function(e) {
      Lyric.preventIfAndroid(e);
      UIActions.startListDrag(this.state.elem);
      return this.sortTouchMove(e);
    },
    sortTouchEnd: function(e) {
      this.state.elem.style["-webkit-transform"] = "translateY(0px)";
      return UIActions.endListDrag();
    },
    sortTouchMove: function(e) {
      var posY;
      posY = e.touches[0].clientY - 31 - drag_prompt.offsetHeight + project_menu_body.scrollTop;
      this.state.elem.style["-webkit-transform"] = "translateY(" + posY + "px)";
      return UIActions.draggingListItem(e.touches[0].clientY);
    },
    onTouchStart: function(e) {
      var checkHold, touch;
      touch = e.touches[0];
      this.state.touch_origin = [e.touches[0].clientX, e.touches[0].clientY];
      this.state.handle = [e.touches[0].clientX - this.state.elem.offsetLeft, e.touches[0].clientY - this.state.elem.offsetTop];
      if (!this.state.sorting) {
        if (!this.checkingHold) {
          checkHold = this.checkHold;
          UIActions.checkHold(this.state.elem);
          this.checkoutHold_timeout = setTimeout((function() {
            return checkHold();
          }), 1000);
          Lyric.State.checkoutHold_timeout = this.checkoutHold_timeout;
          this.checkingHold = true;
        }
        return UIActions.hideHoldMenu();
      }
    },
    onTouchEnd: function(e) {
      this.touch_origin = null;
      this.checkingHold = false;
      clearTimeout(this.checkingHold_timeout);
      return UIActions.removeCheckHold();
    },
    onTouchMove: function(e) {},
    render: function() {
      var className, elem_id, elements, hash, label, onClick_command, sorting;
      elem_id = this.props.id_start + "_" + this.props.hash;
      onClick_command = this.props.click_command;
      sorting = this.state.sorting;
      hash = this.props.hash;
      elements = [];
      label = unescape(this.props.title);
      if (label.length === 0) {
        label = "Verse";
      }
      elements.push(React.DOM.div({
        className: "title",
        onClick: function(e) {
          if ((sorting != null) && !sorting) {
            return onClick_command();
          }
        }
      }, label));
      elements.push(Button.get("list_sort", {
        onTouchStart: this.sortTouchStart,
        onTouchMove: this.sortTouchMove,
        onTouchEnd: this.sortTouchEnd
      }));
      className = "";
      if (this.props.className) {
        className = this.props.className;
      }
      if (this.state.drag_over) {
        className += " sorting";
      }
      return React.DOM.li({
        id: elem_id,
        className: className,
        onTouchStart: this.onTouchStart,
        onTouchMove: this.onTouchMove,
        onTouchEnd: this.onTouchEnd
      }, elements);
    }
  })
};
